// CablanDoc.cpp : implementation of the CCablanDoc class
//

#include "stdafx.h"
#include "Cablan.h"
#include "CablanDoc.h"
#include "math.h"
#include  <malloc.h> 
#include "DialogFileManager.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCablanDoc

IMPLEMENT_DYNCREATE(CCablanDoc, CDocument)

BEGIN_MESSAGE_MAP(CCablanDoc, CDocument)
	//{{AFX_MSG_MAP(CCablanDoc)
	ON_COMMAND(ID_FILE_OPENDTM, OnFileOpendtm)
	ON_COMMAND(ID_FILE_OPENVOLUME, OnFileOpenvolume)
	ON_COMMAND(ID_FILE_OPENSTREAMS, OnFileOpenstreams)
	ON_COMMAND(ID_FILE_OPENROADS, OnFileOpenroads)
	ON_COMMAND(ID_INPUTDATA_HARVESTUNITBOUNDARY_BYFILE, OnInputdataHarvestunitboundaryByfile)
	ON_COMMAND(ID_LANDINGS_FILEMANAGER_OPENLANDINGS, OnLandingsFilemanagerOpenlandings)
	ON_COMMAND(ID_LANDINGS_FILEMANAGER_SAVELANDINGS, OnLandingsFilemanagerSavelandings)
	ON_COMMAND(ID_CABLEWAYS_FILEMANAGER_OPENFILE, OnCablewaysFilemanagerOpenfile)
	ON_COMMAND(ID_CABLEWAYS_FILEMANAGER_SAVEFILE, OnCablewaysFilemanagerSavefile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CCablanDoc, CDocument)
	//{{AFX_DISPATCH_MAP(CCablanDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//      DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_ICablan to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {F949A9EE-AE92-455C-A0DD-16951B6DAEFB}
static const IID IID_ICablan =
{ 0xf949a9ee, 0xae92, 0x455c, { 0xa0, 0xdd, 0x16, 0x95, 0x1b, 0x6d, 0xae, 0xfb } };

BEGIN_INTERFACE_MAP(CCablanDoc, CDocument)
	INTERFACE_PART(CCablanDoc, IID_ICablan, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCablanDoc construction/destruction

CCablanDoc::CCablanDoc()
{
	// TODO: add one-time construction code here

	EnableAutomation();

	AfxOleLockApp();
}

CCablanDoc::~CCablanDoc()
{
	AfxOleUnlockApp();
}

BOOL CCablanDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CCablanDoc serialization

void CCablanDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CCablanDoc diagnostics

#ifdef _DEBUG
void CCablanDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CCablanDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCablanDoc commands

void CCablanDoc::OnFileOpendtm() 
{
	CString csFileName="";
	int lowerleftx, lowerlefty, cellsize;
	float temp;
	int nodata;
	int i, j;
	FILE *infile_ptr;
	char string[200];
	char ch[1];


	DTMmaxZ = -9999;
	DTMminZ = 9999;


//rewrite file to meter
//	FILE *outfile_ptr;
//	CString tempString;
//	int elevation;

//	tempString = "e:/thesis/rockcreek/dem.dat";
//	outfile_ptr = fopen(tempString, "w");



//	CDialogFileManager dlgFile(TRUE, "dat", NULL, OFN_HIDEREADONLY,"All Files (*.*)|*.*|Data Files (*.dat; *.txt)|*.dat;*.txt|", NULL);
	
//	if (dlgFile.DoModal() == IDOK)
//	{
//		csFileName = dlgFile.GetPathName();

	if (DEMFile != "")
	{
		
		csFileName = DEMFile;
		
		if (!csFileName)
			AfxMessageBox("Unable to open the file", MB_OK, MB_ICONEXCLAMATION);
		else
		{
			infile_ptr = fopen(csFileName, "rb");
	
			fread(&string, 10, 1, infile_ptr);   //read the information in front of data
			fscanf(infile_ptr, "%d", &DTMcolumns);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &DTMrows);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &lowerleftx);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &lowerlefty);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &cellsize);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);
			
			fread(&string, 13, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &nodata);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			DTMcellsize = cellsize;
			DTMminX = lowerleftx;
			DTMminY = lowerlefty;
			DTMmaxX = lowerleftx + cellsize * (DTMcolumns-1);
			DTMmaxY = lowerlefty + cellsize * (DTMrows-1);


			for (j=1; j<=DTMrows; j++)  //read elevation data
			{
				for (i=1; i<=DTMcolumns; i++)
				{
					fscanf(infile_ptr, "%f", &temp);
					DTMCoord[i][j].z = (int)temp; // i represents columns(x) and j represents rows(y)

					//correction of terrain data
					//i = CorrectionTerrainData(i, j);

//rewrite the file with meter
//					if (temp > 0.)
//						elevation = (int)(temp * .3048);
//					else
//						elevation = (int) temp;
//					fprintf(outfile_ptr, "%d ", elevation);



					if ( temp > DTMmaxZ )
						DTMmaxZ = (int)temp;
					if ( temp < DTMminZ && temp >= 0)
						DTMminZ = (int)temp;

					DTMCoord[i][j].x = lowerleftx + cellsize * (i-1);    //x coordinate, the left point 49800
					DTMCoord[i][j].y = lowerlefty + cellsize * (DTMrows-j) ;  //y coordinate, the lowest point 4650600
				}
//				fprintf(outfile_ptr, "\n");
			}
			fclose(infile_ptr);
//			fclose(outfile_ptr);
		}
	}
	

		
	//setting initial Unit boundary
	UnitBoundary.startCol = 1;
	UnitBoundary.startRow = 1;
	UnitBoundary.endCol = DTMcolumns;
	UnitBoundary.endRow = DTMrows;

	//input 0 to FishStreams[][] for the case of no stream layer available.
	memset(FishStreams, 0, sizeof(FishStreams));
	memset(FishStreamBuffer, 0, sizeof(FishStreamBuffer));

}

void CCablanDoc::FileGenerator()
{
/*
	//for converting volume layer
	int i, j;
	FILE *outfile_ptr;
	CString tempString;
	float volume;

	tempString = "e:/thesis/McDunn/SouthZone/thinnvolume.dat";
	outfile_ptr = fopen(tempString, "w");
	
	for (j = 1; j <= DTMrows; ++j)
	{
		for (i = 1; i <= DTMcolumns; ++i)
		{
			
//			//convert from bf/ac -> bf/grid cell
//			volume = (float)((double)Volume[i][j] * 2.47 * 0.01);//1 ha = 2.47 acres; one cell = 0.01 ha
//			//convert from bf/grid cell to m3/grid cell
//			volume = (float)((double)volume * 5.7 / 1000.0);//1mbf = 5.7 m3
//			fprintf(outfile_ptr, "%f ", volume);
			

			//volume to be harvested (thinning 50% of current inventory but not more than 110 m3/ha (8000 bf/ac)).
			if (Volume[i][j] > 2.2)
				volume = (float)1.1;
			else
				volume = (float)((double)Volume[i][j] / 2.0);
			fprintf(outfile_ptr, "%f ", volume);
		}
		fprintf(outfile_ptr, "\n");
	}
	fclose(outfile_ptr);
*/



}


void CCablanDoc::OnFileOpenvolume() 
{
	OpenFileforVolume();
	//FileGenerator();
}


void CCablanDoc::OpenFileforVolume() 
{
	int i,j;
	int tempDTMcolumns, tempDTMrows;
	int lowerleftx, lowerlefty, cellsize;
	float temp;
	int nodata;

	FILE *infile_ptr;
	char string[200];
	char ch[1];

	DTMCOORD tempDTMCoord[MAXCOLUMNS][MAXROWS];

	CString csFileName="";
	
//	CDialogFileManager dlgFile(TRUE, "dat", NULL, OFN_HIDEREADONLY,"All Files (*.*)|*.*|Data Files (*.dat; *.txt)|*.dat;*.txt|", NULL);
//	
//	if (dlgFile.DoModal() == IDOK)
//	{
//		csFileName = dlgFile.GetPathName();
	if (VolumeFile != "")
	{
		csFileName = VolumeFile;
	
		if (!csFileName)
			AfxMessageBox("Unable to open the file", MB_OK, MB_ICONEXCLAMATION);
		else
		{
			infile_ptr = fopen(csFileName, "rb");
	
			fread(&string, 10, 1, infile_ptr);   //read the information in front of data
			fscanf(infile_ptr, "%d", &tempDTMcolumns);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &tempDTMrows);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &lowerleftx);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &lowerlefty);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &cellsize);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);
			
			fread(&string, 13, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &nodata);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);		    
			
		
			for (j = 1; j <= tempDTMrows; j++)  //read elevation data
			{
				for (i = 1; i <= tempDTMcolumns; i++)
				{
					fscanf(infile_ptr, "%f", &temp);
					if (temp < 0.)//nodata
						temp = 0.;

					Volume[i][j] = temp; // i represents rows and j represents columns

					tempDTMCoord[i][j].x = lowerleftx + cellsize * (i-1);    //x coordinate, the left point 49800
					tempDTMCoord[i][j].y = lowerlefty + cellsize * (tempDTMrows-j) ;  //y coordinate, the lowest point 4650600
				}
			}
			fclose(infile_ptr);
		}
	}

	
	//maching with DTM
	int kepti, keptj;
	int newi, newj;
	
	if ((int)cellsize != DTMcellsize)
		AfxMessageBox("Grid size is different from that of DTM.", MB_OK, MB_ICONEXCLAMATION);
	else
	{
		if (tempDTMCoord[1][1].y > DTMCoord[1][1].y)//this layer is bigger than DTM. positive going up
		{
			for (j = 1; j <= tempDTMrows; j++)  //read elevation data
			{
				if ( abs(tempDTMCoord[1][j].y - DTMCoord[1][1].y) <= DTMcellsize / 2 )
				{
					keptj = j;
					break;
				}
			}
			newj = keptj - 1;
		}
		else
		{
			for (j = 1; j <= DTMrows; j++)  //read elevation data
			{
				if ( abs(tempDTMCoord[1][1].y - DTMCoord[1][j].y) <= DTMcellsize / 2 )
				{
					keptj = j;
					break;
				}
			}
			newj = -keptj + 1;
		}

		if (tempDTMCoord[1][1].x < DTMCoord[1][1].x)//this layer is bigger than DTM
		{
			for (i = 1; j <= tempDTMcolumns; i++)  //read elevation data
			{
				if ( abs(tempDTMCoord[i][1].x - DTMCoord[1][1].x) <= DTMcellsize / 2 )
				{
					kepti = i;
					break;
				}
			}
			newi = kepti - 1;
		}
		else
		{
			for (i = 1; j <= DTMcolumns; i++)  //read elevation data
			{
				if ( abs(tempDTMCoord[1][1].x - DTMCoord[i][1].x) <= DTMcellsize / 2 )
				{
					kepti = i;
					break;
				}
			}
			newi = -kepti + 1;
		}

		for (j = 1; j <= DTMrows; ++j)
		{
			for (i = 1; i <= DTMcolumns; i++)
			{
				if (newi+i >= 1 && newi+i <= tempDTMcolumns && newj+j >= 1 && newj+j <= tempDTMrows)
					OriginalVolume[i][j] = Volume[newi+i][newj+j];
				else
					OriginalVolume[i][j] = 0.0;
			}
		}

		memcpy(Volume, OriginalVolume, sizeof(Volume));
	}

}


void CCablanDoc::OnFileOpenstreams() 
{
	OpenFileforStream();	
}


void CCablanDoc::OpenFileforStream() 
{
	int i,j;
	int tempDTMcolumns, tempDTMrows;
	int lowerleftx, lowerlefty, cellsize;
	int temp;
	int nodata;

	FILE *infile_ptr;
	char string[200];
	char ch[1];

	DTMCOORD tempDTMCoord[MAXCOLUMNS][MAXROWS];
	short tempFishStreams[MAXCOLUMNS][MAXROWS];

	CString csFileName="";
	
//	CDialogFileManager dlgFile(TRUE, "dat", NULL, OFN_HIDEREADONLY,"All Files (*.*)|*.*|Data Files (*.dat; *.txt)|*.dat;*.txt|", NULL);	
//
//	if (dlgFile.DoModal() == IDOK)
//	{
//		csFileName = dlgFile.GetPathName();

	if (StreamFile != "")
	{
		csFileName = StreamFile;
		
		if (!csFileName)
			AfxMessageBox("Unable to open the file", MB_OK, MB_ICONEXCLAMATION);
		else
		{
			infile_ptr = fopen(csFileName, "rb");
	
			fread(&string, 10, 1, infile_ptr);   //read the information in front of data
			fscanf(infile_ptr, "%d", &tempDTMcolumns);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &tempDTMrows);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &lowerleftx);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &lowerlefty);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &cellsize);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);
			
			fread(&string, 13, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &nodata);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);		    
			
//		    csFileName = "E:/thesis/data/stream.txt";
//			FILE *infile_ptr;
			
			for (j = 1; j <= tempDTMrows; j++)  //read elevation data
			{
				for (i = 1; i <= tempDTMcolumns; i++)
				{
					fscanf(infile_ptr, "%d", &temp);
					if (temp < 0)//nodata
						temp = 0;
					tempFishStreams[i][j] = temp; // i represents rows and j represents columns

					tempDTMCoord[i][j].x = lowerleftx + cellsize * (i-1);    //x coordinate, the left point 49800
					tempDTMCoord[i][j].y = lowerlefty + cellsize * (tempDTMrows-j) ;  //y coordinate, the lowest point 4650600
				}
			}
			fclose(infile_ptr);
		}
	}

	
	//maching with DTM
	int kepti, keptj;
	int newi, newj;
	
	if ((int)cellsize != DTMcellsize)
		AfxMessageBox("Grid size is different from that of DTM.", MB_OK, MB_ICONEXCLAMATION);
	else
	{
		if (tempDTMCoord[1][1].y > DTMCoord[1][1].y)//this layer is bigger than DTM
		{
			for (j = 1; j <= tempDTMrows; j++)  //read elevation data
			{
				if ( abs(tempDTMCoord[1][j].y - DTMCoord[1][1].y) <= DTMcellsize / 2 )
				{
					keptj = j;
					break;
				}
			}
			newj = keptj - 1;
		}
		else//this layer is smaller than DTM
		{
			for (j = 1; j <= DTMrows; j++)  //read elevation data
			{
				if ( abs(tempDTMCoord[1][1].y - DTMCoord[1][j].y) <= DTMcellsize / 2 )
				{
					keptj = j;
					break;
				}
			}
			newj = -keptj + 1;
		}

		if (tempDTMCoord[1][1].x < DTMCoord[1][1].x)//this layer is bigger than DTM
		{
			for (i = 1; j <= tempDTMcolumns; i++)  //read elevation data
			{
				if ( abs(tempDTMCoord[i][1].x - DTMCoord[1][1].x) <= DTMcellsize / 2 )
				{
					kepti = i;
					break;
				}
			}
			newi = kepti - 1;
		}
		else//this layer is smaller than DTM
		{
			for (i = 1; j <= DTMcolumns; i++)  //read elevation data
			{
				if ( abs(tempDTMCoord[1][1].x - DTMCoord[i][1].x) <= DTMcellsize / 2 )
				{
					kepti = i;
					break;
				}
			}
			newi = -kepti + 1;
		}
		
		//transform
		for (j = 1; j <= DTMrows; ++j)
		{
			for (i = 1; i <= DTMcolumns; i++)
			{
				if (newi+i >= 1 && newi+i <= tempDTMcolumns && newj+j >= 1 && newj+j <= tempDTMrows)
					FishStreams[i][j] = tempFishStreams[newi+i][newj+j];
				else
					FishStreams[i][j] = 0;
			}
		}
	}

}


void CCablanDoc::OnFileOpenroads() 
{
	OpenFileforRoad();
}


void CCablanDoc::OpenFileforRoad()
{
	int i,j;
	int tempDTMcolumns, tempDTMrows;
	int lowerleftx, lowerlefty, cellsize;
	int temp;
	int nodata;

	FILE *infile_ptr;
	char string[200];
	char ch[1];

	DTMCOORD tempDTMCoord[MAXCOLUMNS][MAXROWS];
	short tempExistingRoads[MAXCOLUMNS][MAXROWS];

	CString csFileName="";
	
//	CDialogFileManager dlgFile(TRUE, "dat", NULL, OFN_HIDEREADONLY,"All Files (*.*)|*.*|Data Files (*.dat; *.txt)|*.dat;*.txt|", NULL);	
//
//	if (dlgFile.DoModal() == IDOK)
//	{
//		csFileName = dlgFile.GetPathName();

	if (RoadFile != "")
	{
		csFileName = RoadFile;
		
		if (!csFileName)
			AfxMessageBox("Unable to open the file", MB_OK, MB_ICONEXCLAMATION);
		else
		{
			infile_ptr = fopen(csFileName, "rb");
	
			fread(&string, 10, 1, infile_ptr);   //read the information in front of data
			fscanf(infile_ptr, "%d", &tempDTMcolumns);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &tempDTMrows);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &lowerleftx);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &lowerlefty);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &cellsize);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);
			
			fread(&string, 13, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &nodata);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);		    
			
			
			for (j = 1; j <= tempDTMrows; j++)  //read elevation data
			{
				for (i = 1; i <= tempDTMcolumns; i++)
				{
					fscanf(infile_ptr, "%d", &temp);
					if (temp < 0)//nodata
						temp = 0;
					tempExistingRoads[i][j] = temp; // i represents rows and j represents columns

					tempDTMCoord[i][j].x = lowerleftx + cellsize * (i-1);    //x coordinate, the left point 49800
					tempDTMCoord[i][j].y = lowerlefty + cellsize * (tempDTMrows-j) ;  //y coordinate, the lowest point 4650600
				}
			}
			fclose(infile_ptr);
		}
	}

	
	//maching with DTM
	int kepti, keptj;
	int newi, newj;
	
	if ((int)cellsize != DTMcellsize)
		AfxMessageBox("Grid size is different from that of DTM.", MB_OK, MB_ICONEXCLAMATION);
	else
	{
		if (tempDTMCoord[1][1].y > DTMCoord[1][1].y)//this layer is bigger than DTM
		{
			for (j = 1; j <= tempDTMrows; j++)  //read elevation data
			{
				if ( abs(tempDTMCoord[1][j].y - DTMCoord[1][1].y) <= DTMcellsize / 2 )
				{
					keptj = j;
					break;
				}
			}
			newj = keptj - 1;
		}
		else//this layer is smaller than DTM
		{
			for (j = 1; j <= DTMrows; j++)  //read elevation data
			{
				if ( abs(tempDTMCoord[1][1].y - DTMCoord[1][j].y) <= DTMcellsize / 2 )
				{
					keptj = j;
					break;
				}
			}
			newj = -keptj + 1;
		}

		if (tempDTMCoord[1][1].x < DTMCoord[1][1].x)//this layer is bigger than DTM
		{
			for (i = 1; j <= tempDTMcolumns; i++)  //read elevation data
			{
				if ( abs(tempDTMCoord[i][1].x - DTMCoord[1][1].x) <= DTMcellsize / 2 )
				{
					kepti = i;
					break;
				}
			}
			newi = kepti - 1;
		}
		else//this layer is smaller than DTM
		{
			for (i = 1; j <= DTMcolumns; i++)  //read elevation data
			{
				if ( abs(tempDTMCoord[1][1].x - DTMCoord[i][1].x) <= DTMcellsize / 2 )
				{
					kepti = i;
					break;
				}
			}
			newi = -kepti + 1;
		}
		
		//transform
		for (j = 1; j <= DTMrows; ++j)
		{
			for (i = 1; i <= DTMcolumns; i++)
			{
				if (newi+i >= 1 && newi+i <= tempDTMcolumns && newj+j >= 1 && newj+j <= tempDTMrows)
					ExistingRoads[i][j] = tempExistingRoads[newi+i][newj+j];
				else
					ExistingRoads[i][j] = 0;
			}
		}
	}
	
}




void CCablanDoc::OnInputdataHarvestunitboundaryByfile() 
{
	OpenFileforHarvestArea();	
	SettingHarvestUnitBoundary();
}



void CCablanDoc::OpenFileforHarvestArea()
{
	//open file and fill out the array "HarvestArea[][]"
	int i,j;
	int tempDTMcolumns, tempDTMrows;
	int lowerleftx, lowerlefty, cellsize;
	int temp;
	int nodata;

	FILE *infile_ptr;
	char string[200];
	char ch[1];

	DTMCOORD tempDTMCoord[MAXCOLUMNS][MAXROWS];
	short tempHarvestArea[MAXCOLUMNS][MAXROWS];

	CString csFileName="";
	
//	CDialogFileManager dlgFile(TRUE, "dat", NULL, OFN_HIDEREADONLY,"All Files (*.*)|*.*|Data Files (*.dat; *.txt)|*.dat;*.txt|", NULL);	
//
//	if (dlgFile.DoModal() == IDOK)
//	{
//		csFileName = dlgFile.GetPathName();

	if (HarvestAreaFile != "")
	{
		csFileName = HarvestAreaFile;
		
		if (!csFileName)
			AfxMessageBox("Unable to open the file", MB_OK, MB_ICONEXCLAMATION);
		else
		{
			infile_ptr = fopen(csFileName, "rb");
	
			fread(&string, 10, 1, infile_ptr);   //read the information in front of data
			fscanf(infile_ptr, "%d", &tempDTMcolumns);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &tempDTMrows);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &lowerleftx);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &lowerlefty);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);

			fread(&string, 10, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &cellsize);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);
			
			fread(&string, 13, 1, infile_ptr); 
			fscanf(infile_ptr, "%d", &nodata);
			do
			{
				fread(&ch,1,1,infile_ptr);
			}while(ch[0] != 10);		    
			
			//read data
			for (j = 1; j <= tempDTMrows; j++)
			{
				for (i = 1; i <= tempDTMcolumns; i++)
				{
					fscanf(infile_ptr, "%d", &temp);
					if (temp < 0)//nodata
						temp = 0;
					tempHarvestArea[i][j] = temp; // i represents rows and j represents columns

					tempDTMCoord[i][j].x = lowerleftx + cellsize * (i-1);    //x coordinate, the left point 49800
					tempDTMCoord[i][j].y = lowerlefty + cellsize * (tempDTMrows-j) ;  //y coordinate, the lowest point 4650600
				}
			}
			fclose(infile_ptr);
		}
	}

	
	//maching with DTM
	int kepti, keptj;
	int newi, newj;
	
	if ((int)cellsize != DTMcellsize)
		AfxMessageBox("Grid size is different from that of DTM.", MB_OK, MB_ICONEXCLAMATION);
	else
	{
		if (tempDTMCoord[1][1].y > DTMCoord[1][1].y)//this layer is bigger than DTM
		{
			for (j = 1; j <= tempDTMrows; j++)  //read elevation data
			{
				if ( abs(tempDTMCoord[1][j].y - DTMCoord[1][1].y) <= DTMcellsize / 2 )
				{
					keptj = j;
					break;
				}
			}
			newj = keptj - 1;
		}
		else//this layer is smaller than DTM
		{
			for (j = 1; j <= DTMrows; j++)  //read elevation data
			{
				if ( abs(tempDTMCoord[1][1].y - DTMCoord[1][j].y) <= DTMcellsize / 2 )
				{
					keptj = j;
					break;
				}
			}
			newj = -keptj + 1;
		}

		if (tempDTMCoord[1][1].x < DTMCoord[1][1].x)//this layer is bigger than DTM
		{
			for (i = 1; j <= tempDTMcolumns; i++)  //read elevation data
			{
				if ( abs(tempDTMCoord[i][1].x - DTMCoord[1][1].x) <= DTMcellsize / 2 )
				{
					kepti = i;
					break;
				}
			}
			newi = kepti - 1;
		}
		else//this layer is smaller than DTM
		{
			for (i = 1; j <= DTMcolumns; i++)  //read elevation data
			{
				if ( abs(tempDTMCoord[1][1].x - DTMCoord[i][1].x) <= DTMcellsize / 2 )
				{
					kepti = i;
					break;
				}
			}
			newi = -kepti + 1;
		}
		
		//transform (from newi, newj to i,j)
		for (j = 1; j <= DTMrows; ++j)
		{
			for (i = 1; i <= DTMcolumns; i++)
			{
				if (newi+i >= 1 && newi+i <= tempDTMcolumns && newj+j >= 1 && newj+j <= tempDTMrows)
					HarvestArea[i][j] = tempHarvestArea[newi+i][newj+j];
				else
					HarvestArea[i][j] = 0;
			}
		}
	}
	
}

void CCablanDoc::SettingHarvestUnitBoundary()
{
	//when only GIS layer is available for the unit boundary
	//also look at SettingHarvestingUnitBoundary() in View
	int i, j;
	int mincol, minrow, maxcol, maxrow;
	int countcells;//total number of cells falling in the harvest area

	mincol = MAXCOLUMNS;
	minrow = MAXROWS;
	maxcol = 0;
	maxrow = 0;


	//if harvesting unit is already input from GIS layer
	//setting a large boundary for data from GIS layer
	for (j = 1; j <= DTMrows; ++j)
	{
		for (i = 1; i <= DTMcolumns; i++)
		{
			if (HarvestArea[i][j] > 0)
			{
				++countcells;
				CellsWithinUnitBoundary[i][j] = TRUE;
				if (maxcol < i)
					maxcol = i;
				if (mincol > i)
					mincol = i;
				if (maxrow < j)
					maxrow = j;
				if (minrow > j)
					minrow = j;
			}
		}
	}


	//keep this rectangle data in global variables.
	UnitBoundary.startCol = mincol;
	UnitBoundary.startRow = minrow;
	UnitBoundary.endCol = maxcol;
	UnitBoundary.endRow = maxrow;

}



int CCablanDoc::CorrectionTerrainData(int column, int row)
{
	// this subroutine is necessary when elevation data is written seperately along two lines.
	// ex 1000  1-
	//    198
	// this data correct algorithm is good only in case of
	// j>2 and that most of data are bigger than 100m
	// this data correct algorithm should not be applied for
	// low altitude areas (lower than 100m)

	int beforelast = 0;
	int last = 0;
	int current = 0;
	
	if (column > 2)
	{
		current = DTMCoord[column][row].z;
		last = DTMCoord[column-1][row].z;
		beforelast = DTMCoord[column - 2][row].z;
	
		if (last < beforelast/2 && current < beforelast/2)
		{
			if (current<10)
				last = last*10 + current;
			else if (current<100)
				last = last*100 + current;
			else if (current<1000)
				last = last*1000 + current;

			DTMCoord[column-1][row].z = last;
			DTMCoord[column][row].z = 0;
			return(column-1);
		}
	}
	return(column);

}






//////////////////////////////////////////////////////////////////////////////////////////////
//********************************************************************************************
//From NETWORK2000 ---------------------------------------------------------------------------
//********************************************************************************************
//////////////////////////////////////////////////////////////////////////////////////////////




////////////////////////////////////////////////////////
///   Managing from the Link and the Sale Editor ///////
///	     for Shortest Path Algorithm             ///////
////////////////////////////////////////////////////////

void CCablanDoc::DataManager()
{
	////////////////////////////////////////////////////////////////////////////
	//This subroutine is for
	//1. Managing user input data (Link file) for sending to the shortest path algorithm.
	//   - sorting user data with respect to the Fromnode 
	//   - reordering Tonode, VariableCost, and Fixed cost so that they can follow sorted Fromnode order 
	//   - relabeling nodes as numerical values instead of CString.
	//   - FromNode and ToNode are CStrings -> Node[i][0] and Node[i][1] are numbers
	//	 - couting the total number of nodes (this might be different from the total number of links, 
	//     since same node can be used more than once.
	//   - setting TemporaryVariableCost[] and TemporaryFixedCost[] as the original costs
	//     they are gonna change if there are negative costs in any links
	//   - dealing with two way links with Fixed cost  --> see CalculateTotalCosts(), CalculateVariableandFixedCostsperSale(), and CalculateRevisedVariableCost()
	//2. Managing user Sale data (Link file)
	//   - counting the total number of sales by checking how many rows are uesd in the Sale editor(MSflexgrid).
	//   - sorting user data by Year 
	//   - reordering EntryNode, DestNode, and Volume so that they can follow sorted Year order 
	//   - relabeling entry nodes and destination nodes. They must be used in link file at least once.
	//     EntryNode[] and DestNode[] are CStrings -> Entry[] and Destination[] are numbers
	//   - setting TemporaryVolume[] as the original volume data. They will change if users continueing iterations
	////////////////////////////////////////////////////////////////////////////
	//This routine is called by OnShortestpathRun()

	IsDataReady = TRUE;


	//managing data from LinkEditor
	int i, j, k;
	CString tempFromNode[MAX_LINKS];
	int SortedLinkOrderbyFromNode[MAX_LINKS];

	for (i = 1; i <= TotalNumberofLinks; ++i)
	{
		tempFromNode[i] = ConvertfromCharToCString(Links[i].FromNode);
		SortedLinkOrderbyFromNode[i] = i;
	}
	
	Shell_Sorting(tempFromNode, SortedLinkOrderbyFromNode, TotalNumberofLinks);
	

	//change all data with respect to sorted FromNode
	float tempVariableCost[MAX_LINKS];
	float tempFixedCost[MAX_LINKS];
	char tempToNode[MAX_LINKS][MAX_CHAR];
	bool tempLinkExclusion[MAX_LINKS];
	int tempIndexforLinkOrder[MAX_LINKS];
	float tempdist[MAX_LINKS];
	float tempslope[MAX_LINKS];
	float tempsideslope[MAX_LINKS];

	for (i = 1; i <= TotalNumberofLinks; ++i)
	{
		tempVariableCost[i] = Links[i].VariableCost;
		strcpy(tempToNode[i], Links[i].ToNode);
		tempFixedCost[i] = Links[i].FixedCost;
		tempLinkExclusion[i] = LinkExclusion[i];
		tempIndexforLinkOrder[i] = IndexforLinkOrder[i];
		//just for the report
		tempdist[i] = tempDist[i];
		tempslope[i] = tempSlope[i];
		tempsideslope[i] = tempSideSlope[i];
	}

	//keep sorted results
	for (i = 1; i <= TotalNumberofLinks; ++i)//change order of VariableCost and tonode
	{
		ConvertfromCStringToChar(Links[i].FromNode, tempFromNode[i]);//this is already sorted
		strcpy(Links[i].ToNode, tempToNode[SortedLinkOrderbyFromNode[i]]);//this is already sorted
		Links[i].VariableCost = tempVariableCost[SortedLinkOrderbyFromNode[i]];
		Links[i].FixedCost = tempFixedCost[SortedLinkOrderbyFromNode[i]];
		LinkExclusion[i] = tempLinkExclusion[SortedLinkOrderbyFromNode[i]];
		IndexforLinkOrder[i] = tempIndexforLinkOrder[SortedLinkOrderbyFromNode[i]];
		tempDist[i] = tempdist[SortedLinkOrderbyFromNode[i]];
		tempSlope[i] = tempslope[SortedLinkOrderbyFromNode[i]];
		tempSideSlope[i] = tempsideslope[SortedLinkOrderbyFromNode[i]];
	}


	//numbering nodes --- nodes in CString has been already sorted
	Links[0].FromNode[0] = '\0';
	int tempNewNumber = 0;
	for (i = 1; i <= TotalNumberofLinks; ++i)
	{
		if (strcmp(Links[i].FromNode, Links[i-1].FromNode) != 0)//compare two consecutive links
		{
			++tempNewNumber;
			strcpy(Label_NumberToString[tempNewNumber], Links[i].FromNode);
		}

		//Data input for the ShortestPath Algorithm
		Node[i][0] = tempNewNumber;//assign new number label 
	}
	

	for (i = 1; i <= TotalNumberofLinks; ++i)
	{
		Node[i][1] = 0;//initialize for ToNode
		for (j = 1; j <= tempNewNumber; ++j)
		{
			if (strcmp(Links[i].ToNode, Label_NumberToString[j]) == 0)//if ToNode label is the same with one of FromNode's
			{
				//Data input for the ShortestPath Algorithm
				Node[i][1] = j;//put the same number label
				break;
			}
		}


		if (Node[i][1] == 0)//if not changed. That means the ToNode is a new label and it must be one of destinations.
		{
			++tempNewNumber;
			Node[i][1] = tempNewNumber;//assign a new number label which is one greater than the others
			strcpy(Label_NumberToString[tempNewNumber], Links[i].ToNode);
		}
	}

	TotalNumberofNodes = tempNewNumber;//keep total number of nodes identified

	

	
	
	
	///////////////////////////////////////////////////
	//managing data from Sale Editor

	if (TotalNumberofSales == 0)
	{
		AfxMessageBox("No sale data are available. Please check your sale file.", MB_ICONSTOP);
		IsDataReady = FALSE;
	}


	///////////////////////////////////////
	//** Sorting sales 
	//1. sorting by year first
	//2. take sales having same year and then sort them by volume
	///////////////////////////////////////
	
	//define variables
	short tempYear[MAX_SALES];
	float tempVolume[MAX_SALES];
	unsigned short SortedSaleOrderbyYearandVolume[MAX_SALES];

	char tempEntry[MAX_SALES][MAX_CHAR];
	char tempDest[MAX_SALES][MAX_CHAR];
	bool tempSaleExclusion[MAX_SALES];
	unsigned short tempIndexforSaleOrder[MAX_SALES];
	unsigned short currentyear;
	unsigned short startingsale;
	unsigned short endingsale;
	bool sorterror;
	//to make sure sorting
	unsigned short l;
	char temp1[MAX_CHAR], temp2[MAX_CHAR];
	float tempfloat;
	bool tempbool;
	unsigned short temporder;	

	
	//sorting sales by year
	for (i = 1; i <= TotalNumberofSales; ++i)
	{
		tempYear[i] = Sales[i].Year;
		SortedSaleOrderbyYearandVolume[i] = i;
	}

	SortingSalesbyYear(tempYear, SortedSaleOrderbyYearandVolume, TotalNumberofSales);

	//keep original order into temporary arrays except for year
	for (i = 1; i <= TotalNumberofSales; ++i)
	{
		strcpy(tempEntry[i], Sales[i].EntryNode);
		strcpy(tempDest[i], Sales[i].DestNode);
		tempVolume[i] = Sales[i].Volume;
		tempSaleExclusion[i] = SaleExclusion[i];
		tempIndexforSaleOrder[i] = IndexforSaleOrder[i];
	}

	//reordering Entry, Dest, and Volume
	for (i = 1; i <= TotalNumberofSales; ++i)//change order of cost and tonode
	{
		Sales[i].Year = tempYear[i];//this is already sorted
		strcpy(Sales[i].EntryNode, tempEntry[SortedSaleOrderbyYearandVolume[i]]);
		strcpy(Sales[i].DestNode, tempDest[SortedSaleOrderbyYearandVolume[i]]);
		Sales[i].Volume = tempVolume[SortedSaleOrderbyYearandVolume[i]];
		SaleExclusion[i] = tempSaleExclusion[SortedSaleOrderbyYearandVolume[i]];
		IndexforSaleOrder[i] = tempIndexforSaleOrder[SortedSaleOrderbyYearandVolume[i]];
	}


	//sort by volume within a group of sales having same year
	for (i = 1; i <= TotalNumberofSales; ++i)
	{
		currentyear = Sales[i].Year;
		startingsale = i;
		endingsale = i+1;
		while (currentyear == Sales[endingsale].Year && endingsale <= TotalNumberofSales)
			++endingsale;
	
		if (endingsale - startingsale > 1)//if equal to 1, don't have to run sorting
		{
			do
			{
				for (j = startingsale; j < endingsale; ++j)//not including endingsale
				{
					tempVolume[j - startingsale + 1] = Sales[j].Volume;
					SortedSaleOrderbyYearandVolume[j - startingsale + 1] = j - startingsale + 1;//start from 1
				}

				SortingSalesbyVolume(tempVolume, SortedSaleOrderbyYearandVolume, endingsale - startingsale);

				//keep original order into temporary arrays except for year
				for (j = startingsale; j < endingsale; ++j)
				{
					strcpy(tempEntry[j - startingsale + 1], Sales[j].EntryNode);
					strcpy(tempDest[j - startingsale + 1], Sales[j].DestNode);
					tempYear[j - startingsale + 1] = Sales[j].Year;
					tempSaleExclusion[j - startingsale + 1] = SaleExclusion[j];
					tempIndexforSaleOrder[j - startingsale + 1] = IndexforSaleOrder[j];
				}

				//reordering Entry, Dest, and Volume
				for (j = startingsale; j < endingsale; ++j)
				{
					Sales[j].Volume = tempVolume[j - startingsale + 1];//this is already sorted
					Sales[j].Year = tempYear[SortedSaleOrderbyYearandVolume[j - startingsale + 1]];
					strcpy(Sales[j].EntryNode, tempEntry[SortedSaleOrderbyYearandVolume[j - startingsale + 1]]);
					strcpy(Sales[j].DestNode, tempDest[SortedSaleOrderbyYearandVolume[j - startingsale + 1]]);
					SaleExclusion[j] = tempSaleExclusion[SortedSaleOrderbyYearandVolume[j - startingsale + 1]];
					IndexforSaleOrder[j] = tempIndexforSaleOrder[SortedSaleOrderbyYearandVolume[j - startingsale + 1]];
				}

				//make sure sorting worked o.k.
				sorterror = FALSE;
				for (j = startingsale; j < endingsale - 1; ++j)
				{
					if (Sales[j].Volume < Sales[j+1].Volume)
					{
						//sorterror = TRUE;//if you add this line, the algorithm continues until sorting result is correct, but dangerous cause it could run forever.

						//keep original order into temporary arrays except for year
						for (k = startingsale; k < endingsale - 1; ++k)
						{
							if (Sales[j+1].Volume <= Sales[k].Volume && Sales[j+1].Volume >= Sales[k+1].Volume)
							{
								//keep notsortedvolume sale(Sales[j+1]) to temporary variable
								//don't have to change Year since they have same year
								strcpy(temp1, Sales[j+1].EntryNode);
								strcpy(temp2, Sales[j+1].DestNode);
								tempfloat = Sales[j+1].Volume;
								tempbool = SaleExclusion[j+1];
								temporder = IndexforSaleOrder[j+1];
								for (l = j+1; l > k+1; --l)//not including k+1 since considering l-1
								{
									strcpy(Sales[l].EntryNode, Sales[l-1].EntryNode);
									strcpy(Sales[l].DestNode, Sales[l-1].DestNode);
									Sales[l].Volume = Sales[l-1].Volume;
									SaleExclusion[l] = SaleExclusion[l-1];
									IndexforSaleOrder[l] = IndexforSaleOrder[l-1];
								}
								//restore k+1 with j+1
								strcpy(Sales[k+1].EntryNode, temp1);
								strcpy(Sales[k+1].DestNode, temp2);
								Sales[k+1].Volume = tempfloat;
								SaleExclusion[k+1] = tempbool;
								IndexforSaleOrder[k+1] = temporder;
							}
						}


					}

				}
			}while (sorterror == TRUE);//resort until no sort error occurs

			i = endingsale - 1;
		}
	}


	
    
	/////////////////////////////////////////////////////
	//assign nodes in number label to Entry[] and Destination[]
	CString tempString;
	for (i = 1; i <= TotalNumberofSales; ++i)
	{
		Entry[i] = 0;//initializing
		for (j = 1; j <= TotalNumberofNodes; ++j)
		{
			if (strcmp(Sales[i].EntryNode, Label_NumberToString[j]) == 0)//compare two string labels
			{
				Entry[i] = j;//input label in number
				break;
			}
		}
		if (Entry[i] == 0 && SaleExclusion[i] != TRUE)
		{
			tempString.Format("Entry node, %s, is not in the Link file", Sales[i].EntryNode);
			AfxMessageBox(tempString, MB_ICONEXCLAMATION);
			IsDataReady = FALSE;
		}


		Destination[i] = 0;//initializing
		for (j = 1; j <= TotalNumberofNodes; ++j)
		{
			if (strcmp(Sales[i].DestNode, Label_NumberToString[j]) == 0)//compare two string labels
			{
				Destination[i] = j;//input label in number
				break;
			}
		}
		if (Destination[i] == 0 && SaleExclusion[i] != TRUE)
		{
			tempString.Format("Destination node, %s, is not in the Link file", Sales[i].DestNode);
			AfxMessageBox(tempString, MB_ICONEXCLAMATION);
			IsDataReady = FALSE;
		}
	}

}


void CCablanDoc::PreparingDataforShortestPath()
{
	//check Negative values in variable and fixed costs and put data into TemporaryVariableCost[] and TemporaryFixedCost[].
	//add penalties to excluded links

	int i;
	
	float SmallestNegativeVariableCost = 0.0;
	float SmallestNegativeFixedCost = 0.0;

	for (i = 1; i <= TotalNumberofLinks; ++i)
	{
		if (SmallestNegativeVariableCost > Links[i].VariableCost)
			SmallestNegativeVariableCost = Links[i].VariableCost;
		if (SmallestNegativeFixedCost > Links[i].FixedCost)
			SmallestNegativeFixedCost = Links[i].FixedCost;
	}

	for (i = 1; i <= TotalNumberofLinks; ++i)
	{
		if (LinkExclusion[i] != TRUE)
		{
			if (Links[i].VariableCost < 0)
				TemporaryVariableCost[i] = Links[i].VariableCost + (float)fabs(SmallestNegativeVariableCost);//also look at CalculateTotalCosts()
			else
				TemporaryVariableCost[i] = Links[i].VariableCost;

			if (Links[i].FixedCost < 0)
				TemporaryFixedCost[i] = Links[i].FixedCost + (float)fabs(SmallestNegativeFixedCost);//also look at CalculateTotalCosts()
			else
				TemporaryFixedCost[i] = Links[i].FixedCost;
		}
		else
		{//for the link which is excluded. Put large costs so that they are not going to be chosen for the final path
			TemporaryVariableCost[i] = (float)9999999999999999999.9;
			TemporaryFixedCost[i] = (float)9999999999999999999.9;
		}
	}

	//put original volume data into TemporaryVolume[]
	for (i = 1; i <= TotalNumberofSales; ++i)
		TemporaryVolume[i] = Sales[i].Volume;

}


////////////////////////////////////////////////////////////////////
////   Shell Sorting   /////////////////////////////////////////////
////////////////////////////////////////////////////////////////////

void CCablanDoc::Shell_Sorting(CString x[], int o[], int n)
{
	////////////////////////////////////////////////////////////////////////////
	//This subroutine is for
	//1. sorting Fromnode CSTring array.
	//2. keeping trace of order using Order array.
	//This routine is from Rojiani's book page 431.
	////////////////////////////////////////////////////////////////////////////
	// This routine is called by DataManager()

	CString temp;
	int i;
	int last;
	bool is_sorted;
	int jump=n/2;

	int temp_o;

	while (jump >= 1)
	{
		last = n - jump;
		is_sorted = FALSE;

		while (!is_sorted)
		{
			is_sorted = TRUE;
			for (i = 1; i <= last; ++i)
			//i starts from 1 and end at last, since the x and o array start from [1] instead [0]
			{
				if (x[i].Compare(x[i+jump]) > 0)
				{
					temp = x[i];
					x[i] = x[i+jump];
					x[i+jump] = temp;
					is_sorted = FALSE;

					temp_o = o[i];
					o[i] = o[i+jump];
					o[i+jump] = temp_o;
				}
			}
		}
		jump = jump/2;
	}
}





//////////////////////////////////////////////////
///  ShortestPath Running  ///////////////////////
//////////////////////////////////////////////////



void CCablanDoc::InitializingShortestPathAlgorithm()
{
	///////////////////////////////////////////////////////////
	//This subroutine is for
	//1. initializing variables for the ShortestPathAlgorithm()
	////////////////////////////////////////////////////////////////////////////
	// This routine is called by OnShortestPathRun()

	int j;

	NNN = 0;
	NCM = 0;
	M = 0;
	KPLK = 0;
	KPNCM = 0;
	for (j = 1; j <= TotalNumberofNodes; ++j)
	{
		NDPT[j] = 0;
		TCUM[j] = 0.0;
		TSUM[j] = 0.0;
		NCUM[j] = 0;
		NOTO[j] = 0;
		NPRED[j] = 0;
		IPTOR[j] = 0;
	}
	NDPT[IO] = TotalNumberofLinks + 1;//a number beyond the range(9999 in the original code)
	NNN = IO;

	//determine what link is using each node firstly
	IPTOR[Node[1][0]] = 1;

	for (j = 2; j <= TotalNumberofLinks; ++j)
	{
		if (Node[j][0] != Node[j-1][0])
			IPTOR[Node[j][0]] = j;		
	}

}


void CCablanDoc::ShortestPathAlgorithm(int IDNumber)
{

	////////////////////////////////////////////////////////////////////////////
	//This subroutine is for
	//1. conducting shortest path algorithm
	//The sorce is from Dr. John Sessions.
	////////////////////////////////////////////////////////////////////////////
	// This routine is called by OnShortestPathRun()

//error handler starts
__try
{
	if (Error == TRUE)
	{
		NumberofLinksinPath = 0;
		return;
	}
 
	int i, j, k;


//	//verifying node connection
//	if (IPTOR[NNN] == 0)
//	{
//		//printf("Stop! This Node %d is not in network", NNN);
//		CString temp;
//		temp.Format("Stop! This Node %d is not in network", NNN);
//		AfxMessageBox(temp, MB_ICONEXCLAMATION);
//		//return;
//	}
		
	if (IPTOR[NNN] != 0)//in case of the node is dead end, skip following for next statement.
	{
		for (j = IPTOR[NNN]; j <= TotalNumberofLinks; ++j)//220
		{
	
			if (NDPT[Node[j][1]] != TotalNumberofLinks + 1)
			{
				NCM++;

				TCUM[NCM] = TSUM[Node[j][0]] + Cost[j];
				//printf ("%f %f %d\n", TCUM[NCM], Cost[j], j);
				NCUM[NCM] = j;

				if (NDPT[Node[j][1]] == 0)
				{
					NDPT[Node[j][1]] = NCM;
					if (Node[j][0] != Node[j+1][0])
						break;//stop the loop
				}
				else
				{
					if (TCUM[NCM] < TCUM[NDPT[Node[j][1]]])
					{
						TCUM[NDPT[Node[j][1]]] = TCUM[NCM];
						NCUM[NDPT[Node[j][1]]] = NCUM[NCM];
					}
					--NCM;
					if (Node[j][0] != Node[j+1][0])
						break;//stop the loop
				}
			}
			else
			{
				if (Node[j][0] != Node[j+1][0])
					break;//stop the loop
			}
		}//the end of for-next statement(j)
	}//end of if (IPTOR[NNN] != 0) statement
		

	TMIN = (float)999999999999999999999999999.0;
	

	for (k = 1; k < NCM + 1; ++k)
	{
		if (TMIN > TCUM[k])
		{
			TMIN = TCUM[k];
			KPLK = NCUM[k];
			KPNCM = k;
		}
	}

	NNN = Node[KPLK][1];
	M++;
	NOTO[M] = NNN;
	TSUM[NNN] = TMIN;
	NPRED[M] = Node[KPLK][0];
	NDPT[NNN] = TotalNumberofLinks + 1;
	
	if (NNN != DEST)
	{
		if (KPNCM == NCM)
		{
			--NCM;
			ShortestPathAlgorithm(IDNumber);
		}
		else
		{
			TCUM[KPNCM] = TCUM[NCM];
			NCUM[KPNCM] = NCUM[NCM];
			NDPT[Node[NCUM[NCM]][1]] = KPNCM;
			--NCM;
			ShortestPathAlgorithm(IDNumber);
		}
	}
	else
	{
		//keep results here
		FinalPath[1] = DEST;
		FinalPath[2] = NPRED[M];
		NumberofLinksinPath = 2;

		DEST = NPRED[M];
	}

	
	while (DEST != IO)
	{
		for (i = 1; i < M+1; ++i)
		{
			if (NOTO[i] == DEST)
			{
				//keep results here
				++NumberofLinksinPath;
				FinalPath[NumberofLinksinPath] = NPRED[i];

				DEST = NPRED[i];
				break;
			}
		}
	}

}

//error handling  --> links are not connected to Destination
__except(EXCEPTION_EXECUTE_HANDLER)
{
	AfxMessageBox("ERROR!!! Network2000 can't solve this problem. The reason might be one of the followings. 1.Your destination node may not be connected to the origin node.  2.Network2000 encountered a disconnected link while trying to keep lower volume limit constraints. Remember! Entering lower volume limit should be restricted to few links which are in the very end of your network 3.Network2000 can't find any feasible solutions satisfying the volume limits you entered.", MB_ICONSTOP);
	AfxMessageBox("Please, SAVE your file IMMEADIATELY. This program will be closed with further operations without correction.", MB_ICONEXCLAMATION);
	InitializingShortestPathAlgorithm();
	DEST = 0;
	IO = 0;
	NumberofLinksinPath = 0;
	Error = TRUE;
	return;
}



}





void CCablanDoc::SortingSalesbyYear(short x[], unsigned short o[], unsigned short n)
{
	////////////////////////////////////////////////////////////////////////////
	//This subroutine is for
	//1. sorting Fromnode CSTring array.
	//2. keeping trace of order using Order array.
	//This routine is from Rojiani's book page 435.
	////////////////////////////////////////////////////////////////////////////
	// This routine is called by DataManager()

	unsigned short temp;
	unsigned short i;
	unsigned short last;
	bool is_sorted;
	unsigned short jump=n/2;

	unsigned short temp_o;

	while (jump >= 1)
	{
		last = n - jump;
		is_sorted = FALSE;

		while (!is_sorted)
		{
			is_sorted = TRUE;
			for (i = 1; i <= last; ++i)
			//i starts from 1 and end at last, since the x and o array start from [1] instead of [0]
			{
				if (x[i] > x[i+jump])
				{
					temp = x[i];
					x[i] = x[i+jump];
					x[i+jump] = temp;
					is_sorted = FALSE;

					temp_o = o[i];
					o[i] = o[i+jump];
					o[i+jump] = temp_o;
				}
			}
		}
		jump = jump/2;
	}
}



void CCablanDoc::SortingSalesbyVolume(float x[], unsigned short o[], unsigned short n)
{
	////////////////////////////////////////////////////////////////////////////
	//This subroutine is for
	//1. sorting Fromnode CSTring array.
	//2. keeping trace of order using Order array.
	//This routine is from Rojiani's book page 435.
	////////////////////////////////////////////////////////////////////////////
	// This routine is called by DataManager()

	float temp;
	unsigned short i;
	unsigned short last;
	bool is_sorted;
	unsigned short jump=n/2;

	unsigned short temp_o;

	while (jump >= 1)
	{
		last = n - jump;
		is_sorted = FALSE;

		while (!is_sorted)
		{
			is_sorted = TRUE;
			for (i = 1; i <= last; ++i)
			//i starts from 1 and end at last, since the x and o array start from [1] instead of [0]
			{
				if (x[i] < x[i+jump])
				{
					temp = x[i];
					x[i] = x[i+jump];
					x[i+jump] = temp;
					is_sorted = FALSE;

					temp_o = o[i];
					o[i] = o[i+jump];
					o[i+jump] = temp_o;
				}
			}
		}
		jump = jump/2;
	}
}


void CCablanDoc::AddAccumulatedVolume(int IDNumber)
{
	////////////////////////////////////////////////////////////////////////////
	//This subroutine is for
	//1. calculating total volume passing each link.
	//   this volume will be used as a sign showing the link being used.
	////////////////////////////////////////////////////////////////////////////
	// This routine is called by OnShortestPathRun()
	// This routine calls FindLinkNumberbetweenTwoNodes()
	// Set TwoWayLink[].IsUsedLater-->see DataManager(), AddAccumulatedVolume(), CalculateTotalCosts(), CalculateVariableandFixedCostsperSale(), and CalculateRevisedVariableCost()

	int i;
	int tempLinkNumber = 0;

	for (i = 1; i < NumberofLinksinPath; ++i)//not include <= sign because next node(j+1) will be looked at
	{
		tempLinkNumber = FindLinkNumberbetweenTwoNodes(FinalPath[i+1], FinalPath[i]);//convert nodes to link number
		//from node will be Path[i+1] and to node will be Path[i]

		//if Year is not 0, then depreciates volume instead of depreciating variable costs--> same results
		TemporaryAccumulatedVolumeperLink[tempLinkNumber] += TemporaryVolume[IDNumber] / (float)pow((1.0+InterestRate), (double)Sales[IDNumber].Year);
		AccumulatedVolumeperLink[tempLinkNumber] += Sales[IDNumber].Volume / (float)pow((1.0+InterestRate), (double)Sales[IDNumber].Year);

		//recover Cost[] which used in current sale <-- from Network Flowchart by Dr. Sessions
		Cost[tempLinkNumber] = TemporaryVariableCost[tempLinkNumber];
		Cost_BackUp[tempLinkNumber] = Cost[tempLinkNumber];
		
		if (FirstUseYearofLink[tempLinkNumber] < 0)
			FirstUseYearofLink[tempLinkNumber] = Sales[IDNumber].Year;
		
		if (FirstUseSaleofLink[tempLinkNumber] == 0)
			FirstUseSaleofLink[tempLinkNumber] = IDNumber;//sale number			
	}
}






int CCablanDoc::FindLinkNumberbetweenTwoNodes(int fromNode, int toNode)
{
	////////////////////////////////////////////////////////////////////////////
	//This subroutine is for
	//1. find link number (label) based on from node and to node
	////////////////////////////////////////////////////////////////////////////
	// This routine is called by CalculateAccumulatedVolume()

	int i;
	int linkNo = 0;

	for (i = 1; i <= TotalNumberofLinks; ++i)
	{
		if (Node[i][0] == fromNode && Node[i][1] == toNode)
		{
			linkNo = i;
			break;
		}
	}

	return(linkNo);
}


void CCablanDoc::CalculateRevisedVariableCost()
{
	////////////////////////////////////////////////////////////////////////////
	//This subroutine is for
	//1. calculating link cost (variable and fixed/sumofvolume)
	//2. using TemporaryVariableCost[] and TemporaryFixedCost[]
	//   they don't have any negative values. --> just for shortestpath algorithm
	////////////////////////////////////////////////////////////////////////////
	// This routine is called by ShortestPathRun()
	// This routine is called by CalculateTotalCosts()
	// This routine is dealing with Two way links --> see DataManager(), AddAccumulatedVolume(), CalculateTotalCosts(), CalculateVariableandFixedCostsperSale(), and CalculateRevisedVariableCost()

	int i;
	int tempLinkNumber = 0;

	//reinput cost for the links in the current solution
	for (i = 1; i <= TotalNumberofLinks; ++i)
	{
		if (TemporaryAccumulatedVolumeperLink[i] > 0)//if the link is in the solution, it has certain amount of volume in the AccumulatedVolumeperLink array
		{
			Cost[i] = TemporaryVariableCost[i] + (TemporaryFixedCost[i] / TemporaryAccumulatedVolumeperLink[i]);//revise Cost[] for the links in the current solution 
			Cost_BackUp[i] = Cost[i];
		}
	}
}




void CCablanDoc::ChangeSaleOrder()
{

	int i;
	float tempTotalCostsperSale[MAX_SALES];
	unsigned short SortedSaleOrderbyTotalCostsperSale[MAX_SALES];

	
	//sorting sales by year
	for (i = 1; i <= TotalNumberofSales; ++i)
	{
		tempTotalCostsperSale[i] = TotalCostsperSale[i];
		SortedSaleOrderbyTotalCostsperSale[i] = i;
	}

	SortingSalesbyVolume(tempTotalCostsperSale, SortedSaleOrderbyTotalCostsperSale, TotalNumberofSales);
	memcpy(SaleOrder, SortedSaleOrderbyTotalCostsperSale, sizeof(SaleOrder));


//the following codes are from NETWORK2000 -- randomly sorting sales.

	//Keep Year order
	//change order of sale within the same year sales

	int j, k;
	int numberofsaleshavingsameyear;
	bool error = FALSE;

	for (i = 1; i <= TotalNumberofSales; ++i)
	{
		numberofsaleshavingsameyear = 1;
		j = i;
		while (Sales[++j].Year == Sales[i].Year && j <= TotalNumberofSales)
			++numberofsaleshavingsameyear;
		

		for (j = i; j < i + numberofsaleshavingsameyear; ++j)
		{
			do//until select one order which is never selected. --> not very efficient way to do...
			{
				SaleOrder[j] = i + rand() % numberofsaleshavingsameyear;
				error = FALSE;
				for (k = i; k < j; ++k)
				{
					if (SaleOrder[j] == SaleOrder[k])
					{
						error = TRUE;
						break;
					}
				}
			}while (error == TRUE);
		}
		i += numberofsaleshavingsameyear - 1;//1 will be added to i by the for statement 
	}

}



void CCablanDoc::ShortestPathRun()
{
	////////////////////////////////////////////////////////////////////////////
	//This subroutine is for
	//1. initializing variables for conducting shortest path algorithm by calling InitializingShortestPathAlgorithm()
	//	 -initializing Results variables
	//2. First iteration
	//   - find the shortest path for each sale without considering volume and fixedcost
	//3. Put negative value(-99999.9) into every link as variable cost which are not in the current solution
	//4. Continue Shortest path iteration
	//   - calculate total volume passing at each link
	//   - recalculate variable cost which includes fixed cost based on the volume passed
	//	   for the links in the current solution (if the variable cost is -99999.9, it is going to change to positive value)
	//   - keep the former results
	//   - initializing variables for keeping results of shortest path algorithm
	//   - Run shortest path algorithm with revised variable costs
	//     until the current solution is the same with the former one
	////////////////////////////////////////////////////////////////////////////
	// This routine is called by User's Clicking on the menu bar
	// This routine calls	InitializingShortestPathAlgorith()
	//						ShortestPathAlgorithm()
	//						CalculateAccumulatedVolume();
	//						CalculateRevisedVariableCost();
	/////////////////////////////////////////////////////////////////////////////

	//Flowchart
	//1. InitializingShortestPathAlgorithm
	//2. ShortestPathAlgorithm()--> generating a current solution
	//3. AddAccumulatedVolume()--> has to be done at each sales
	//4. CalculateTotalCosts()--> after shortest paths for all sales are found



//	//for measurign time
//	COleDateTime timeStart, timeEnd;
//	COleDateTimeSpan spanElapsed;
//	double TotalDay, TotalHour, TotalMinute, TotalSecond;
//	//time start
//	timeStart = COleDateTime::GetCurrentTime();
//	//end of measuring time


	int i, j, k;
	CString tempString;
	Error = FALSE;//initialize error handler 
	short PreventInfiniteLoopingCount = 0;
	double tolerance;
	float tempBestAccumulatedVolumeperLink[MAX_LINKS];//temporary variables for keeping the best.

	//saving results(trends of optimization)
	FILE *outfile_ptr;
	outfile_ptr = fopen(csTempOutputFile, "w");//csTempOutputFile is global in Doc.h and is set in OnNetworkOptimization() in View


	
	//initializing Results
	//following two variables are global ones and they keep only current one sale.
	for (i = 1; i <= TotalNumberofSales; ++i)
	{
		FinalPath[i] = 0;
		NumberofLinksinPath = 0;
		TotalCostsperSale[i] = 0.0;
	}

	float CurrentTotalCost = 0.0;
	float FormerTotalCost = 0.0;
	Method = 0;//for reporting to file
	

	//FIRST ITERATION
	++IterationNo;//BestIterationNo and IterationNo will be reset to Zero whenever SP restarts
	//input data to Cost[] array for the algorithm
	for (i = 1; i <= TotalNumberofLinks; ++i)
	{
		Cost[i] = TemporaryVariableCost[i];
		Cost_BackUp[i] = Cost[i];
		AccumulatedVolumeperLink[i] = 0.0;//initializing--> this will contain orginal fixed sale volume (Sales[].Volume)
		TemporaryAccumulatedVolumeperLink[i] = 0.0;//initializing--> this will contain TemporaryVolume which will change in further iterations.
		FirstUseYearofLink[i] = -1;//initializing
		FirstUseSaleofLink[i] = 0;
	}
	
	//reset Sale order to original one
	for (i = 1; i <= TotalNumberofSales; ++i)
		SaleOrder[i] = i;

	//first iteration
	for (i = 1; i <= TotalNumberofSales; ++i)
	{
		CurrentPath[i] = "";//CString
		if (SaleExclusion[i] != TRUE)
		{
			//set Entry and Dest
			IO = Entry[i];
			DEST = Destination[i];

			InitializingShortestPathAlgorithm();
			ShortestPathAlgorithm(i);//i means ID number for each sale
			//recording the result into CString
			tempString.Format("%7d", NumberofLinksinPath);
			CurrentPath[i] = tempString;
			for (j = NumberofLinksinPath; j >= 1; --j)//reorder nodes--entry node will place the first
			{
				tempString.Format("%7d", FinalPath[j]);
				CurrentPath[i] += tempString;
			}
			AddAccumulatedVolume(i);
		}
	}


	//calculate total cost and keep it
	float tempfloat = 0.;
	for (i = 1; i <= TotalNumberofSales; ++i)
	{
		TotalCostsperSale[i] = CalculateCostsperSale(i, CurrentPath[i]);
		tempfloat += TotalCostsperSale[i];//to check if total cost is the same as CurrentTotalCost;
	}
	CalculateTotalCosts();
	CurrentTotalCost = (float)TotalVariableandFixedCosts;


	//NEGATIVE VALUE
	//Put negative value in the links which are not in the current solution.
	//here, all links have negative value,
	//and then the links in the current solution will have positive cost in the CalculateRevisedVariableCost() subroutine in the next loop
	for (i = 1; i <= TotalNumberofLinks; ++i)
	{
		Cost[i] = (float)-99999999.9;	
		Cost_BackUp[i] = Cost[i];//Cost[] can be altered for a penalty in ReviseVariableCostBasedonVolumeLimitAfterhand(i) and ~~Beforehand() and Cost[] can be restored at ~~Beforehand() using Cost_BackUp[]
	}


	int TemporaryOrigin;
	int TemporaryDest;
	int tempNumberofLinksinPath;
	

	//NEXT ITERATIONS
	do
	{
		fprintf(outfile_ptr, "Iteration: %d	CurrentSolution %f\n", IterationNo, CurrentTotalCost);

		//always keep the best one
		if (CurrentTotalCost < TotalCostfromShortestPathAlgorithm)//TotalCostfromShortestPathAlgorithm is set to a large value when SP starts firstly at the View
		{
			BestIterationNo = IterationNo;
			TotalCostfromShortestPathAlgorithm = CurrentTotalCost;
			for (i = 1; i <= TotalNumberofSales; ++i)
				BestPath[i] = CurrentPath[i];
			SaveResultsToFile(BestPath, csFileName);
			memcpy(tempBestAccumulatedVolumeperLink, AccumulatedVolumeperLink, sizeof(tempBestAccumulatedVolumeperLink));
		}


		//changing Cost[] (for shortest path algorithm) so that fixed costs are considered
		CalculateRevisedVariableCost();


		//Keeping the shortestpath former results
		FormerTotalCost = CurrentTotalCost;
		CurrentTotalCost = 0.0;
	
		for (i = 1; i <= TotalNumberofLinks; ++i)
		{
			AccumulatedVolumeperLink[i] = 0.0;//initializing
			TemporaryAccumulatedVolumeperLink[i] = 0.0;//initializing
			FirstUseYearofLink[i] = -1;//initializing
			FirstUseSaleofLink[i] = 0;
		}
	

		//next iteration
		++IterationNo;

		//change sale order based on total costs per sale.
		ChangeSaleOrder();//change Sale order-> generate a different set of SaleOrder[]
		for (k = 1; k <= TotalNumberofSales; ++k)
		{
			i = SaleOrder[k];

			//initializing variable - no volume limit violation check which was used to be NETWORK2000
			TemporaryDest = -1;
			TemporaryOrigin = -1;
			
			CurrentPath[i] = "";//CString
			if (SaleExclusion[i] != TRUE)
			{
				if (TemporaryDest <= 0)//no lower limit is violated
				{
					IO = Entry[i];//set Entry and Dest
					DEST = Destination[i];
					InitializingShortestPathAlgorithm();//this subroutine should be called after IO is set
					ShortestPathAlgorithm(i);//i means ID number for each sale
					tempString.Format("%7d", NumberofLinksinPath);//recording the result into CString
					CurrentPath[i] = tempString;
					for (j = NumberofLinksinPath; j >= 1; --j)//reorder nodes--entry node will place the first
					{
						tempString.Format("%7d", FinalPath[j]);
						CurrentPath[i] += tempString;
					}
				}
				else
				{
					//start find the shortest path from the origin of this sale (i) to the node where the lower-volume-limit link starts
					IO = Entry[i];
					DEST = TemporaryDest;
					if (DEST != IO)
					{
						InitializingShortestPathAlgorithm();
						ShortestPathAlgorithm(i);//i means ID number for each sale
						tempNumberofLinksinPath = NumberofLinksinPath;
						for (j = NumberofLinksinPath; j >= 1; --j)//reorder nodes--entry node will place the first
						{
							tempString.Format("%7d", FinalPath[j]);
							CurrentPath[i] += tempString;
						}//CurrentPath doesn't have total number of nodes in the front yet
					}
					else //if Dest == IO, then ShortestPathAlgorithm() will generate Error!!!, so skip running ShortestPathAlgorithm()
					{
						NumberofLinksinPath = 1;
						tempNumberofLinksinPath = 1;
						tempString.Format("%7d", IO);
						CurrentPath[i] += tempString;
					}

					IO = TemporaryOrigin;
					DEST = Destination[i];
					if (DEST != IO)
					{
						InitializingShortestPathAlgorithm();
						ShortestPathAlgorithm(i);//i means ID number for each sale
						for (j = NumberofLinksinPath; j >= 1; --j)//reorder nodes--entry node will place the first
						{
							tempString.Format("%7d", FinalPath[j]);
							CurrentPath[i] += tempString;
						}
						NumberofLinksinPath += tempNumberofLinksinPath;//correct NumberofNodes
						tempString.Format("%7d", NumberofLinksinPath);//recording the result into CString
						CurrentPath[i] = tempString + CurrentPath[i];
						//reset FinalPath[] array for AddAccumulatedVolume() and further process
						for (j = 1; j <= NumberofLinksinPath; ++j)
							FinalPath[NumberofLinksinPath - j + 1] = atoi(CurrentPath[i].Mid(j*7, 7));//FinalPath[] has reverse order of nodes [1] is Destination
					}
					else  //if Dest == IO, then ShortestPathAlgorithm() will generate Error!!!, so skip running ShortestPathAlgorithm()
					{
						++NumberofLinksinPath;//add one more node
						tempString.Format("%7d", DEST);
						CurrentPath[i] += tempString;//add DEST to CSTring
						tempString.Format("%7d", NumberofLinksinPath);
						CurrentPath[i] = tempString + CurrentPath[i];//put number of nodes in path in the front of CString
						//reset FinalPath[] array for AddAccumulatedVolume() and further process.
						for (j = 1; j <= NumberofLinksinPath; ++j)
							FinalPath[NumberofLinksinPath - j + 1] = atoi(CurrentPath[i].Mid(j*7, 7));//FinalPath[] has reverse order of nodes. [1] is Destination
					}						
				}

				AddAccumulatedVolume(i);//this subroutine is using FinalPath[]
			}
		}

		
		//calculate total cost and keep it
		for (i = 1; i <= TotalNumberofSales; ++i)
		{
			TotalCostsperSale[i] = 0.;
			TotalCostsperSale[i] = CalculateCostsperSale(i, CurrentPath[i]);
		}
				
		CalculateTotalCosts();
		CurrentTotalCost = (float)TotalVariableandFixedCosts;

		if (PreventInfiniteLoopingCount > 100)//get out of infinite loop after 100 iteration without any changes
		{
			if (BestIterationNo == 0)//never gets a feasible solution
			{
				AfxMessageBox("Could not find a feasible solution under the volume limits you entered. Please check your volume limits.", MB_ICONSTOP);
				IsDataReady = FALSE;//no more process allowed
				IsFirstIterationDone = FALSE;//no more process allowed
				return;
			}
			else// at least one feasible solution has ever been found
				break;//go to out of do-while loop
		}
		if (FormerTotalCost == CurrentTotalCost)
			++PreventInfiniteLoopingCount;
		else
			PreventInfiniteLoopingCount = 0;
		
		tolerance = CurrentTotalCost / 100000.0;
	} while (fabs(FormerTotalCost - CurrentTotalCost) > fabs(tolerance) && IterationNo < 200);//1000);//tolerance is 1/1million of the current solution
	//this stopping criterion is very much critical for the quality of the solution and solution time. 
	//also look at OnNetworkOptimizing() in View which has another stopping criterion.		

	//keep the final iteration info.
	fprintf(outfile_ptr, "Iteration: %d	CurrentSolution %f\n", IterationNo, CurrentTotalCost);

	
	//always keep the best one
	if (CurrentTotalCost < TotalCostfromShortestPathAlgorithm)//TotalCostfromShortestPathAlgorithm is set to a large value when SP starts firstly at the View
	{
		BestIterationNo = IterationNo;
		TotalCostfromShortestPathAlgorithm = CurrentTotalCost;
		for (i = 1; i <= TotalNumberofSales; ++i)
			BestPath[i] = CurrentPath[i];
		SaveResultsToFile(BestPath, csFileName);//csFileName is "cablepath.txt"
		//current AccumulatedVolumeperLink[] is the one that the best solution has. Do not need to update.
	}
	else
	{
		//current AccumulatedVolumeperLink[] is not the one saved in file.. Nees to update this variable for the further use (see CablanView CalculateVariableandFixedCostsperSale()).
		//after the following command, BestPath kept in the file will match with AccumulatedVolumeperLink[].
		memcpy(AccumulatedVolumeperLink, tempBestAccumulatedVolumeperLink, sizeof(tempBestAccumulatedVolumeperLink));
	}


	//Error handler
	//if any excluded link is used in the final solution
	for (i = 1; i <= TotalNumberofLinks; ++i)
	{
		if (AccumulatedVolumeperLink[i] > 0 && LinkExclusion[i] == TRUE)//if the link is in the solution but it is excluded by user
		{
			tempString.Format("Caution!!! The link from '%s' to '%s' is disconnected. This link must be included to get to your destination. Currently no feasible solution found.", Links[i].FromNode, Links[i].ToNode);
			AfxMessageBox(tempString, MB_ICONSTOP);
			IsDataReady = FALSE;//no more process allowed
			IsFirstIterationDone = FALSE;//no more process allowed
		}
	}

	
	//Best solution
	fprintf(outfile_ptr, "Best Iteration: %d	BestSolution %f\n", BestIterationNo, TotalCostfromShortestPathAlgorithm);
	fclose(outfile_ptr);

	
/*
	// measuring time
	// ... perform time-consuming task
	timeEnd = COleDateTime::GetCurrentTime();
	spanElapsed = timeEnd - timeStart;
	TotalDay = spanElapsed.GetDays();
	TotalHour = spanElapsed.GetHours();
	TotalMinute = spanElapsed.GetMinutes();
	TotalSecond = spanElapsed.GetSeconds();
	//saving time
	FILE *outfile_ptr;
	CString tempFileTime = "E:\\time.txt";
	outfile_ptr = fopen(tempFileTime, "w");
	fprintf(outfile_ptr, "Day %f\n", TotalDay);
	fprintf(outfile_ptr, "Hour %f\n", TotalHour);
	fprintf(outfile_ptr, "Minute %f\n", TotalMinute);
	fprintf(outfile_ptr, "Second %f\n\n", TotalSecond);
	fclose(outfile_ptr);
	//end of measuring time
*/
}






void CCablanDoc::SaveResultsToFile(CString NodeString[], CString csFileName)
{
	//save result as a file
	int i, j;
	int nodenumber;
	FILE *outfile_ptr;
	CString tempString;
	

	//*****************

	outfile_ptr = fopen(csFileName, "w");
	fprintf(outfile_ptr, "%d\n", Method);//0 indicates this is the shortestpath results
	fprintf(outfile_ptr, "%d\n", TotalNumberofSales);//total number of sales

	for (i = 1; i <= TotalNumberofSales; ++i)
	{
		if (SaleExclusion[i] != TRUE)
		{
			fprintf(outfile_ptr, "%d\n", i);//sale number
			fprintf(outfile_ptr, "%f\n", Sales[i].Volume);//volume
			NumberofLinksinPath = atoi(NodeString[i].Left(7));
			fprintf(outfile_ptr, "%d\n", NumberofLinksinPath);//number of links
			for (j = 1; j <= NumberofLinksinPath; ++j)
			{
				nodenumber = atoi(NodeString[i].Mid(j*7, 7));
				fprintf(outfile_ptr, "%d ", nodenumber);
			}
			fprintf(outfile_ptr, "\n");
		}
	}

	fprintf(outfile_ptr, "%lf\n", TotalVariableCosts);
	fprintf(outfile_ptr, "%lf\n", TotalFixedCosts);
	fprintf(outfile_ptr, "%lf\n", TotalVariableandFixedCosts);
	
	fclose(outfile_ptr);
}



float CCablanDoc::CalculateCostsperSale(int SaleNo, CString NodeString)
{

	float totalcosts = 0.;
	float variablecosts = 0.;
	float fixedcosts = 0.;

	int j;
	int nodenumber1, nodenumber2;
	CString tempString;
	int NumberofLinksinPath;
	int tempLinkNumber;

	NumberofLinksinPath = atoi(NodeString.Left(7));
			
	for (j = 1; j < NumberofLinksinPath; ++j)//not include <= sign because next node(j+1) will be looked at
	{
		nodenumber1 = atoi(NodeString.Mid(j*7, 7));
		nodenumber2 = atoi(NodeString.Mid((j+1)*7, 7));
		tempLinkNumber = FindLinkNumberbetweenTwoNodes(nodenumber1, nodenumber2);//convert nodes to link number
		variablecosts += Links[tempLinkNumber].VariableCost * Sales[SaleNo].Volume;
		if (AccumulatedVolumeperLink[tempLinkNumber] > 0)
			fixedcosts += Links[tempLinkNumber].FixedCost * (Sales[SaleNo].Volume / AccumulatedVolumeperLink[tempLinkNumber]);
	}

	totalcosts = variablecosts + fixedcosts;

	return totalcosts;

}


void CCablanDoc::CalculateTotalCosts()
{
	////////////////////////////////////////////////////////////////////////////
	//This subroutine is for
	//1. if volume data is changed, change them back  -> restore TemporaryVolume[] with original volume data
	//2. calculating Costs based on the shortest path results.
	////////////////////////////////////////////////////////////////////////////
	// This routine is called by ShortestPathRun()
	// This routine is dealing with Two way links --> see DataManager(), AddAccumulatedVolume(), CalculateTotalCosts(), CalculateVariableandFixedCostsperSale(), and CalculateRevisedVariableCost()


	//following three cost variables are global variables
	TotalVariableCosts = 0.0;
	TotalFixedCosts = 0.0;
	TotalVariableandFixedCosts = 0.0;

	int i;

	//calculate costs
	//TotalCosts will be calculated based on the real variable and fixed cost not on the temporary costs
	for (i = 1; i <= TotalNumberofLinks; ++i)
	{
		if (AccumulatedVolumeperLink[i] > 0)//if the link is in the solution, it has a certain amount of volume in the AccumulatedVolumeperLink array
		{
			if (LinkExclusion[i] != TRUE)
			{
				TotalVariableCosts +=  Links[i].VariableCost * AccumulatedVolumeperLink[i];//AccumulatedVolumeperLink[] contains original volumes
				TotalFixedCosts += Links[i].FixedCost / (float)pow((1.0+InterestRate), (double)FirstUseYearofLink[i]);//depreciate fixed cost according to what year the link is used firstly
			}
			else//if Link is excluded, put high cost to make it infeasible.
			{
				TotalVariableCosts += (float)999999999999999.9;
				TotalFixedCosts += (float)999999999999999.9;
			}
		}
	}

	TotalVariableandFixedCosts = TotalVariableCosts + TotalFixedCosts;
}






void CCablanDoc::ConvertfromCStringToChar(char* character, CString cstring)
{
	short templength = cstring.GetLength();
	short i;
	short count = 0;
	
	for (i = 0; i < templength; ++i)
	{
		if (cstring.GetAt(i) != ' ')//there are blanks in strings for numerical value due to the Format of '%15.2f'.
		{
			character[count] = cstring.GetAt(i);
			++count;
		}
	}
	
	character[count] = '\0';
}


CString CCablanDoc::ConvertfromCharToCString(char* character)
{
	CString cstring = "";
	unsigned short i = 0;
	
	while (character[i])
	{
		cstring += " ";//initialize with space
		cstring.SetAt(i, character[i]);//change space with a char
		++i;
	}

	return(cstring);
}








void CCablanDoc::CheckLinkData()
{
	int i, j;
	CString tempString;
	
	//check duplicated links
	for (i = 1; i <= TotalNumberofLinks; ++i)
	{
		for (j = i+1; j <= TotalNumberofLinks; ++j)
		{
			//check duplicated links
			if (strcmp(Links[i].FromNode, Links[j].FromNode) == 0)
			{
				if (strcmp(Links[i].ToNode, Links[j].ToNode) == 0)
				{
					tempString.Format("There is a duplicated link (from '%s' to '%s'). Please delete one.", Links[i].FromNode, Links[i].ToNode);
					AfxMessageBox(tempString, MB_ICONEXCLAMATION);
					return;
				}
			}
		}
	}
}







void CCablanDoc::ChangecsFileName(CString tempString)
{
	csFileName = tempString;
}





///////////////////////////////////////////////////////////////
//LANDINGS - File manager  ////////////////////////////////////
///////////////////////////////////////////////////////////////

void CCablanDoc::OnLandingsFilemanagerOpenlandings() 
{
	int i, landingID;
	FILE *infile_ptr;
	CString tempString;

	
	tempString = LandingFile;
	infile_ptr = fopen(tempString, "r");

	fscanf(infile_ptr, "%d", &TotalNumberofLandings);
	
	for (i = 1; i <= TotalNumberofLandings; ++i)
	{
		fscanf(infile_ptr, "%d", &landingID);
		fscanf(infile_ptr, "%d", &Landings[landingID].column);
		fscanf(infile_ptr, "%d", &Landings[landingID].row);
		fscanf(infile_ptr, "%d", &Landings[landingID].CableSystem);
		fscanf(infile_ptr, "%f", &LandingCosts[landingID]);
		fscanf(infile_ptr, "%d", &LandingSharingTowerID[landingID]);
	}

	fclose(infile_ptr);
}

void CCablanDoc::OnLandingsFilemanagerSavelandings() 
{
	int i;
	FILE *outfile_ptr;
	CString tempString;
	
	tempString = "e:/thesis/output/Landings.dat";
	outfile_ptr = fopen(tempString, "w");

	fprintf(outfile_ptr, "%d\n", TotalNumberofLandings);


	for (i = 1; i <= TotalNumberofLandings; ++i)
	{
		fprintf(outfile_ptr, "%d %d %d %d %f %d\n", i, Landings[i].column, Landings[i].row, Landings[i].CableSystem, LandingCosts[i], LandingSharingTowerID[i]);
	}


	fclose(outfile_ptr);
}



///////////////////////////////////////////////////////////////
//CABLE ROADS - File manager  ////////////////////////////////////
///////////////////////////////////////////////////////////////


void CCablanDoc::SaveFileCableRoads()
{
	int i, j, k;
	FILE *outfile_ptr;
	CString tempString;
	
	tempString = "e:/thesis/output/Cableroaddata.dat";
	outfile_ptr = fopen(tempString, "w");
	fprintf(outfile_ptr, "%d\n", TotalNumberofLandings);
	
	for (i = 1; i <= TotalNumberofLandings; ++i)
	{
		fprintf(outfile_ptr, "%d\n", i);
		for (j = 0; j < MAXCABLEWAYS - 1; ++j)
		{
			fprintf(outfile_ptr, "%d %d %d %d %d %d %10.2f %10.2f %d %10.2f\n", Cableways[i][j].tailcolumn, Cableways[i][j].tailrow, Cableways[i][j].endcolumn, Cableways[i][j].endrow, Cableways[i][j].taillocationID, Cableways[i][j].totalnumberofprofilecells, Cableways[i][j].slope, Cableways[i][j].intercept, Cableways[i][j].totalnumberofINTs, TailSparTreeHeight[i][j]);
			for (k = 1; k <= Cableways[i][j].taillocationID; ++k)
			{
				fprintf(outfile_ptr, "%10.2f %10.2f", CycleTimeAtEachTP[i][j][k], PayloadAtEachTP[i][j][k]);
			}
			fprintf(outfile_ptr, "\n");
			fprintf(outfile_ptr, "%10.2f\n", Payload[i][j]);
		}
	}

	fclose(outfile_ptr);

}

void CCablanDoc::OpenFileCableRoads()
{
	int i, j, k;
	int landing;
	int totalnumberoflandings;
	FILE *infile_ptr;
	CString tempString;
	
	tempString = CableRoadFile;
	infile_ptr = fopen(tempString, "rb");

	fscanf(infile_ptr, "%d", &totalnumberoflandings);
	if (TotalNumberofLandings != totalnumberoflandings)
		AfxMessageBox("Total number of landings is different!", MB_ICONEXCLAMATION);
	else
	{
		for (i = 1; i <= TotalNumberofLandings; ++i)
		{
			fscanf(infile_ptr, "%d", &landing);
			for (j = 0; j < MAXCABLEWAYS - 1; ++j)
			{
//				fscanf(infile_ptr, "%d %d %d %d %d %d %f %f %d", &Cableways[i][j].tailcolumn, &Cableways[i][j].tailrow, &Cableways[i][j].endcolumn, &Cableways[i][j].endrow, &Cableways[i][j].taillocationID, &Cableways[i][j].totalnumberofprofilecells, &Cableways[i][j].slope, &Cableways[i][j].intercept, &Cableways[i][j].totalnumberofINTs);
				fscanf(infile_ptr, "%d %d %d %d %d %d %f %f %d %f\n", &Cableways[i][j].tailcolumn, &Cableways[i][j].tailrow, &Cableways[i][j].endcolumn, &Cableways[i][j].endrow, &Cableways[i][j].taillocationID, &Cableways[i][j].totalnumberofprofilecells, &Cableways[i][j].slope, &Cableways[i][j].intercept, &Cableways[i][j].totalnumberofINTs, &TailSparTreeHeight[i][j]);

				for (k = 1; k <= Cableways[i][j].taillocationID; ++k)
				{
					fscanf(infile_ptr, "%f %f", &CycleTimeAtEachTP[i][j][k], &PayloadAtEachTP[i][j][k]);					
				}
				fscanf(infile_ptr, "%f", &Payload[i][j]);
			}
			boolLandingPayloadAnalysis[i] = TRUE;
		}
	}

	fclose(infile_ptr);
}



void CCablanDoc::OnCablewaysFilemanagerOpenfile() 
{
	OpenFileCableRoads();
}

void CCablanDoc::OnCablewaysFilemanagerSavefile() 
{
	SaveFileCableRoads();
}
