// CableSystemDataInput.cpp : implementation file
//

#include "stdafx.h"
#include "Cablan.h"
#include "CableSystemDataInput.h"
#include "DialogCableOperationData.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCableSystemDataInput dialog


CCableSystemDataInput::CCableSystemDataInput(CWnd* pParent /*=NULL*/)
	: CDialog(CCableSystemDataInput::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCableSystemDataInput)
	m_Beta = 0.0f;
	m_CarriageDepth = 0.0f;
	m_CarriageWeight = 0.0f;
	m_HBLWeight = 0.0f;
	m_IntermediateHeight = 0.0f;
	m_LogDiameter = 0.0f;
	m_LogLength = 0.0f;
	m_MaxSKLTension = 0.0f;
	m_MaxSparHeight = 0.0f;
	m_MinSparHeight = 0.0f;
	m_MaxLateralYDist = 0.0f;
	m_MNLWeight = 0.0f;
	m_MaxYardingDist = 0.0f;
	m_Myu = 0.0f;
	m_SKYWeight = 0.0f;
	m_TowerHeight = 0.0f;
	m_Check_Downhill = FALSE;
	m_Check_English = FALSE;
	m_Clearance = 0.0f;
	m_Deflection = 0.0f;
	m_HaulbackLimit = 0.0f;
	m_MaxChordSlopeChange = 0.0f;
	m_CableSystem = _T("");
	m_CableSystemName = _T("");
	m_Check_HaulbackLine = FALSE;
	m_ChokerLength = 0.0f;
	m_MaxINTSupports = 0;
	m_MaxMainTension = 0.0f;
	//}}AFX_DATA_INIT
}


void CCableSystemDataInput::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCableSystemDataInput)
	DDX_Control(pDX, IDC_COMB_CABLESYSTEM, m_CableSystemCtrl);
	DDX_Text(pDX, IDC_EDIT_BETA, m_Beta);
	DDX_Text(pDX, IDC_EDIT_CARRIAGEDEPTH, m_CarriageDepth);
	DDX_Text(pDX, IDC_EDIT_CARRIAGEWEIGHT, m_CarriageWeight);
	DDX_Text(pDX, IDC_EDIT_HBLWEIGHT, m_HBLWeight);
	DDX_Text(pDX, IDC_EDIT_INTHEIGHT, m_IntermediateHeight);
	DDX_Text(pDX, IDC_EDIT_LOGDIAM, m_LogDiameter);
	DDX_Text(pDX, IDC_EDIT_LOGLENGTH, m_LogLength);
	DDX_Text(pDX, IDC_EDIT_MAXSKLTENSION, m_MaxSKLTension);
	DDX_Text(pDX, IDC_EDIT_MAXSPARHEIGHT, m_MaxSparHeight);
	DDX_Text(pDX, IDC_EDIT_MINSPARHEIGHT, m_MinSparHeight);
	DDX_Text(pDX, IDC_EDIT_MLYD, m_MaxLateralYDist);
	DDX_Text(pDX, IDC_EDIT_MNLWEIGHT, m_MNLWeight);
	DDX_Text(pDX, IDC_EDIT_MYD, m_MaxYardingDist);
	DDX_Text(pDX, IDC_EDIT_MYU, m_Myu);
	DDX_Text(pDX, IDC_EDIT_SKLWEIGHT, m_SKYWeight);
	DDX_Text(pDX, IDC_EDIT_TOWERH, m_TowerHeight);
	DDX_Check(pDX, IDC_CHECK_DOWNHILL, m_Check_Downhill);
	DDX_Check(pDX, IDC_CHECK_ENGLISHUNITS, m_Check_English);
	DDX_Text(pDX, IDC_EDIT_CLEARANCE, m_Clearance);
	DDX_Text(pDX, IDC_EDIT_DEFLECTION, m_Deflection);
	DDX_Text(pDX, IDC_EDIT_HAULBACKLIMIT, m_HaulbackLimit);
	DDX_Text(pDX, IDC_EDIT_MAXCHORDSLOPECHANGE, m_MaxChordSlopeChange);
	DDX_CBString(pDX, IDC_COMB_CABLESYSTEM, m_CableSystem);
	DDX_Text(pDX, IDC_CABLESYSTEMNAME, m_CableSystemName);
	DDV_MaxChars(pDX, m_CableSystemName, 20);
	DDX_Check(pDX, IDC_CHECK_HAULBACKLINE, m_Check_HaulbackLine);
	DDX_Text(pDX, IDC_EDIT_CHOKERLENGTH, m_ChokerLength);
	DDX_Text(pDX, IDC_EDIT_MAXINTSUPPORT, m_MaxINTSupports);
	DDV_MinMaxInt(pDX, m_MaxINTSupports, 0, 20);
	DDX_Text(pDX, IDC_EDIT_MAXMAINTENSION, m_MaxMainTension);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCableSystemDataInput, CDialog)
	//{{AFX_MSG_MAP(CCableSystemDataInput)
	ON_BN_CLICKED(IDC_CHECK_DOWNHILL, OnCheckDownhill)
	ON_BN_CLICKED(IDC_CHECK_ENGLISHUNITS, OnCheckEnglishunits)
	ON_CBN_SELCHANGE(IDC_COMB_CABLESYSTEM, OnSelchangeCombCablesystem)
	ON_EN_CHANGE(IDC_EDIT_BETA, OnChangeEditBeta)
	ON_EN_CHANGE(IDC_EDIT_CARRIAGEDEPTH, OnChangeEditCarriagedepth)
	ON_EN_CHANGE(IDC_EDIT_CARRIAGEWEIGHT, OnChangeEditCarriageweight)
	ON_EN_CHANGE(IDC_EDIT_CLEARANCE, OnChangeEditClearance)
	ON_EN_CHANGE(IDC_EDIT_DEFLECTION, OnChangeEditDeflection)
	ON_EN_CHANGE(IDC_EDIT_HAULBACKLIMIT, OnChangeEditHaulbacklimit)
	ON_EN_CHANGE(IDC_EDIT_HBLWEIGHT, OnChangeEditHblweight)
	ON_EN_CHANGE(IDC_EDIT_INTHEIGHT, OnChangeEditIntheight)
	ON_EN_CHANGE(IDC_EDIT_LOGDIAM, OnChangeEditLogdiam)
	ON_EN_CHANGE(IDC_EDIT_LOGLENGTH, OnChangeEditLoglength)
	ON_EN_CHANGE(IDC_EDIT_MAXCHORDSLOPECHANGE, OnChangeEditMaxchordslopechange)
	ON_EN_CHANGE(IDC_EDIT_MAXSKLTENSION, OnChangeEditMaxskltension)
	ON_EN_CHANGE(IDC_EDIT_MAXSPARHEIGHT, OnChangeEditMaxsparheight)
	ON_EN_CHANGE(IDC_EDIT_MINSPARHEIGHT, OnChangeEditMinsparheight)
	ON_EN_CHANGE(IDC_EDIT_MLYD, OnChangeEditMlyd)
	ON_EN_CHANGE(IDC_EDIT_MNLWEIGHT, OnChangeEditMnlweight)
	ON_EN_CHANGE(IDC_EDIT_MYD, OnChangeEditMyd)
	ON_EN_CHANGE(IDC_EDIT_MYU, OnChangeEditMyu)
	ON_EN_CHANGE(IDC_EDIT_SKLWEIGHT, OnChangeEditSklweight)
	ON_EN_CHANGE(IDC_EDIT_TOWERH, OnChangeEditTowerh)
	ON_BN_CLICKED(IDC_BUTTON1, OnInputMore)
	ON_BN_CLICKED(IDC_CHECK_HAULBACKLINE, OnCheckHaulbackline)
	ON_EN_CHANGE(IDC_CABLESYSTEMNAME, OnChangeCablesystemname)
	ON_EN_CHANGE(IDC_EDIT_CHOKERLENGTH, OnChangeEditChokerlength)
	ON_EN_CHANGE(IDC_EDIT_MAXINTSUPPORT, OnChangeEditMaxintsupport)
	ON_EN_CHANGE(IDC_EDIT_MAXMAINTENSION, OnChangeEditMaxmaintension)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCableSystemDataInput message handlers


void CCableSystemDataInput::OnCheckDownhill() 
{
	UpdateData(TRUE);
	if (m_Check_Downhill == TRUE)
		CableSystems[CurrentSystem].Downhill = TRUE;
	else
		CableSystems[CurrentSystem].Downhill = FALSE;

	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnCheckEnglishunits() 
{
	UpdateData(TRUE);
	if (m_Check_English == TRUE)
		CableSystems[CurrentSystem].English = TRUE;
	else
		CableSystems[CurrentSystem].English = FALSE;

	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnCheckHaulbackline() 
{
	UpdateData(TRUE);
	if (m_Check_HaulbackLine == TRUE)
		CableSystems[CurrentSystem].HaulbackLine = TRUE;
	else
		CableSystems[CurrentSystem].HaulbackLine = FALSE;	

	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}


BOOL CCableSystemDataInput::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	if (CableSystems[CurrentSystem].Downhill == TRUE)
		m_Check_Downhill = TRUE;
	else
		m_Check_Downhill = FALSE;

	if (CableSystems[CurrentSystem].English == TRUE)
		m_Check_English = TRUE;
	else
		m_Check_English = FALSE;

	if (CableSystems[CurrentSystem].HaulbackLine == TRUE)
		m_Check_HaulbackLine = TRUE;
	else
		m_Check_HaulbackLine = FALSE;


	UpdateData(FALSE);


	m_CableSystemCtrl.SetCurSel(CurrentSystem-1);//negative one because SetCurSel() value starts from zero
	UpdateData(TRUE);
	
	m_CableSystemName = CableSystems[CurrentSystem].CableSystemName;
	m_Beta = CableSystems[CurrentSystem].gbBeta;
	m_CarriageDepth = CableSystems[CurrentSystem].gbCarriageDepth;
	m_CarriageWeight = CableSystems[CurrentSystem].gbWc;
	m_HBLWeight = CableSystems[CurrentSystem].gbW4;
	m_IntermediateHeight = CableSystems[CurrentSystem].intermediatesupportheight;
	m_LogDiameter = CableSystems[CurrentSystem].gbDLog;
	m_LogLength = CableSystems[CurrentSystem].gbL;
	m_ChokerLength = CableSystems[CurrentSystem].gbLC;
	m_MaxSKLTension = CableSystems[CurrentSystem].gbTmax;
	m_MaxMainTension = CableSystems[CurrentSystem].gbMmax;
	m_MaxSparHeight = CableSystems[CurrentSystem].maxspartreeheight;
	m_MinSparHeight = CableSystems[CurrentSystem].minspartreeheight;
	m_MaxLateralYDist = CableSystems[CurrentSystem].maxlateraldist;
	m_MNLWeight = CableSystems[CurrentSystem].gbW3;
	m_MaxYardingDist = CableSystems[CurrentSystem].maxyarddist;
	m_Myu = CableSystems[CurrentSystem].gbMyu;
	m_SKYWeight = CableSystems[CurrentSystem].gbW1;
	m_TowerHeight = CableSystems[CurrentSystem].towerheight;
	m_Clearance = CableSystems[CurrentSystem].gbClearance;
	m_Deflection = CableSystems[CurrentSystem].gbAllowableDeflection;
	m_HaulbackLimit = CableSystems[CurrentSystem].gbMinSlopewithoutHBL;
	m_MaxChordSlopeChange  = CableSystems[CurrentSystem].gbMaxSlopeChange;
	m_MaxINTSupports = CableSystems[CurrentSystem].gbMaxINTSupports;
	
	UpdateData(FALSE);

	
	//initializing
	for (int i = 0; i < MAXCABLESYSTEMS; ++i)
		CableSystems[i].boolSpecChangebyUser = FALSE;


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCableSystemDataInput::OnSelchangeCombCablesystem() 
{
	// TODO: Add your control notification handler code here
	CurrentSystem = m_CableSystemCtrl.GetCurSel() + 1;//positive one because SetCurSel() value starts from zero
	m_CableSystemCtrl.SetCurSel(CurrentSystem-1);
	UpdateData(TRUE);

	m_CableSystemName = CableSystems[CurrentSystem].CableSystemName;
	m_Beta = CableSystems[CurrentSystem].gbBeta;
	m_CarriageDepth = CableSystems[CurrentSystem].gbCarriageDepth;
	m_CarriageWeight = CableSystems[CurrentSystem].gbWc;
	m_HBLWeight = CableSystems[CurrentSystem].gbW4;
	m_IntermediateHeight = CableSystems[CurrentSystem].intermediatesupportheight;
	m_LogDiameter = CableSystems[CurrentSystem].gbDLog;
	m_LogLength = CableSystems[CurrentSystem].gbL;
	m_ChokerLength = CableSystems[CurrentSystem].gbLC;
	m_MaxSKLTension = CableSystems[CurrentSystem].gbTmax;
	m_MaxMainTension = CableSystems[CurrentSystem].gbMmax;
	m_MaxSparHeight = CableSystems[CurrentSystem].maxspartreeheight;
	m_MinSparHeight = CableSystems[CurrentSystem].minspartreeheight;
	m_MaxLateralYDist = CableSystems[CurrentSystem].maxlateraldist;
	m_MNLWeight = CableSystems[CurrentSystem].gbW3;
	m_MaxYardingDist = CableSystems[CurrentSystem].maxyarddist;
	m_Myu = CableSystems[CurrentSystem].gbMyu;
	m_SKYWeight = CableSystems[CurrentSystem].gbW1;
	m_TowerHeight = CableSystems[CurrentSystem].towerheight;
	m_Clearance = CableSystems[CurrentSystem].gbClearance;
	m_Deflection = CableSystems[CurrentSystem].gbAllowableDeflection;
	m_HaulbackLimit = CableSystems[CurrentSystem].gbMinSlopewithoutHBL;
	m_MaxChordSlopeChange  = CableSystems[CurrentSystem].gbMaxSlopeChange;
	m_MaxINTSupports = CableSystems[CurrentSystem].gbMaxINTSupports;
	m_Check_Downhill = CableSystems[CurrentSystem].Downhill;
	m_Check_English = CableSystems[CurrentSystem].English;
	m_Check_HaulbackLine = CableSystems[CurrentSystem].HaulbackLine;
	
	UpdateData(FALSE);
}



void CCableSystemDataInput::OnChangeEditBeta() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	UpdateData(TRUE);
	CableSystems[CurrentSystem].gbBeta = m_Beta;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}



void CCableSystemDataInput::OnChangeEditCarriagedepth() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	UpdateData(TRUE);
	CableSystems[CurrentSystem].gbCarriageDepth = m_CarriageDepth;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditCarriageweight() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	UpdateData(TRUE);
	CableSystems[CurrentSystem].gbWc = m_CarriageWeight;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditClearance() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	UpdateData(TRUE);
	CableSystems[CurrentSystem].gbClearance = m_Clearance;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditDeflection() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	UpdateData(TRUE);
	CableSystems[CurrentSystem].gbAllowableDeflection = m_Deflection;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditHaulbacklimit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);
	CableSystems[CurrentSystem].gbMinSlopewithoutHBL = m_HaulbackLimit;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditHblweight() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);
	CableSystems[CurrentSystem].gbW4 = m_HBLWeight;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditIntheight() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);
	CableSystems[CurrentSystem].intermediatesupportheight = m_IntermediateHeight;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditLogdiam() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);
	CableSystems[CurrentSystem].gbDLog = m_LogDiameter;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditLoglength() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);
	CableSystems[CurrentSystem].gbL = m_LogLength;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditChokerlength() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);
	CableSystems[CurrentSystem].gbLC = m_ChokerLength;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditMaxchordslopechange() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);
	CableSystems[CurrentSystem].gbMaxSlopeChange = m_MaxChordSlopeChange;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditMaxintsupport() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);
	CableSystems[CurrentSystem].gbMaxINTSupports = m_MaxINTSupports;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditMaxskltension() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);
	CableSystems[CurrentSystem].gbTmax = m_MaxSKLTension;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}


void CCableSystemDataInput::OnChangeEditMaxmaintension() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);
	CableSystems[CurrentSystem].gbMmax = m_MaxMainTension;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}


void CCableSystemDataInput::OnChangeEditMaxsparheight() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);
	CableSystems[CurrentSystem].maxspartreeheight = m_MaxSparHeight;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditMinsparheight() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);
	CableSystems[CurrentSystem].minspartreeheight = m_MinSparHeight;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditMlyd() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);
	CableSystems[CurrentSystem].maxlateraldist = m_MaxLateralYDist;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditMnlweight() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);
	CableSystems[CurrentSystem].gbW3 = m_MNLWeight;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditMyd() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);
	CableSystems[CurrentSystem].maxyarddist = m_MaxYardingDist;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditMyu() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);
	CableSystems[CurrentSystem].gbMyu = m_Myu;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditSklweight() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);
	CableSystems[CurrentSystem].gbW1 = m_SKYWeight;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
}

void CCableSystemDataInput::OnChangeEditTowerh() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);
	CableSystems[CurrentSystem].towerheight = m_TowerHeight;
	CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
	
}

void CCableSystemDataInput::OnInputMore() 
{
	CDialogCableOperationData dlg;

	dlg.m_Density = CableSystems[CurrentSystem].gbDensity;
	dlg.m_EngineEfficiency = CableSystems[CurrentSystem].gbEngineEfficiency;
	dlg.m_EnginePower = CableSystems[CurrentSystem].gbEnginePower;
	dlg.m_HookTime = CableSystems[CurrentSystem].gbHookTime;
	dlg.m_LoadFactor = CableSystems[CurrentSystem].gbLoadFactor;
	dlg.m_RiggingCosts = CableSystems[CurrentSystem].gbRiggingCosts;
	dlg.m_UnhookTime = CableSystems[CurrentSystem].gbUnhookTime;
	dlg.m_UnitCost = CableSystems[CurrentSystem].gbUnitCost;
	dlg.m_DelayPercentage = CableSystems[CurrentSystem].gbDelayPercentage;
	dlg.m_FellingCosts = CableSystems[CurrentSystem].gbFellingCosts;
	dlg.m_MoveInCosts = CableSystems[CurrentSystem].gbMoveInCosts;
	dlg.m_YarderSetupHour = CableSystems[CurrentSystem].gbYarderSetupHour;
	dlg.m_CableRoadChangeHour = CableSystems[CurrentSystem].gbCableRoadChangeHour;
	dlg.m_UserMaxPayload = CableSystems[CurrentSystem].gbUserMaxPayload;
	dlg.m_UserMinPayload = CableSystems[CurrentSystem].gbUserMinPayload;
	dlg.m_InhaulSpeedLimit = CableSystems[CurrentSystem].gbInhaulSpeedLimit;
	dlg.m_InhaulSpeedLimitFull = CableSystems[CurrentSystem].gbInhaulSpeedLimitFull;
	dlg.m_OuthaulSpeedLimit = CableSystems[CurrentSystem].gbOuthaulSpeedLimit;
	dlg.m_LateralYardingSpeed = CableSystems[CurrentSystem].gbLateralYardingSpeed;
	dlg.m_MultiplierLYD1 = CableSystems[CurrentSystem].gbMultiplierLYD1;
	dlg.m_MultiplierLYD2 = CableSystems[CurrentSystem].gbMultiplierLYD2;
	dlg.m_MultiplierLYD3 = CableSystems[CurrentSystem].gbMultiplierLYD3;	
	dlg.m_PenaltyForBeyondLateralYarding = CableSystems[CurrentSystem].gbPenaltyForBeyondLateralYarding;
	dlg.m_GiveUpCellDistance = CableSystems[CurrentSystem].gbGiveUpCellDistance;
	

	if (dlg.DoModal() == IDOK)
	{
		CableSystems[CurrentSystem].gbDensity = dlg.m_Density;
		CableSystems[CurrentSystem].gbEngineEfficiency = dlg.m_EngineEfficiency;
		CableSystems[CurrentSystem].gbEnginePower = dlg.m_EnginePower;
		CableSystems[CurrentSystem].gbHookTime = dlg.m_HookTime;
		CableSystems[CurrentSystem].gbLoadFactor = dlg.m_LoadFactor;
		CableSystems[CurrentSystem].gbRiggingCosts = dlg.m_RiggingCosts;
		CableSystems[CurrentSystem].gbUnhookTime = dlg.m_UnhookTime;
		CableSystems[CurrentSystem].gbUnitCost = dlg.m_UnitCost;
		CableSystems[CurrentSystem].gbMoveInCosts = dlg.m_MoveInCosts;
		CableSystems[CurrentSystem].gbDelayPercentage = dlg.m_DelayPercentage;
		CableSystems[CurrentSystem].gbFellingCosts = dlg.m_FellingCosts;
		CableSystems[CurrentSystem].gbYarderSetupHour = dlg.m_YarderSetupHour;
		CableSystems[CurrentSystem].gbCableRoadChangeHour = dlg.m_CableRoadChangeHour;
		CableSystems[CurrentSystem].gbUserMaxPayload = dlg.m_UserMaxPayload;
		CableSystems[CurrentSystem].gbUserMinPayload = dlg.m_UserMinPayload;
		CableSystems[CurrentSystem].gbInhaulSpeedLimit = dlg.m_InhaulSpeedLimit;
		CableSystems[CurrentSystem].gbInhaulSpeedLimitFull = dlg.m_InhaulSpeedLimitFull;
		CableSystems[CurrentSystem].gbOuthaulSpeedLimit = dlg.m_OuthaulSpeedLimit;
		CableSystems[CurrentSystem].gbLateralYardingSpeed = dlg.m_LateralYardingSpeed;
		CableSystems[CurrentSystem].gbPenaltyForBeyondLateralYarding = dlg.m_PenaltyForBeyondLateralYarding;
		CableSystems[CurrentSystem].gbMultiplierLYD1 = dlg.m_MultiplierLYD1;
		CableSystems[CurrentSystem].gbMultiplierLYD2 = dlg.m_MultiplierLYD2;
		CableSystems[CurrentSystem].gbMultiplierLYD3 = dlg.m_MultiplierLYD3;
		CableSystems[CurrentSystem].gbGiveUpCellDistance = dlg.m_GiveUpCellDistance;
		
		//indicate the parameters are changed.
		CableSystems[CurrentSystem].boolSpecChangebyUser = TRUE;
	}	
}



void CCableSystemDataInput::OnChangeCablesystemname() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	UpdateData(TRUE);

	short templength = m_CableSystemName.GetLength();
	short i;
	short count = 0;//count is less than 20 by default-- look at ClassWizard and m_CableSystemName. Maximum character is 20.
	
	for (i = 0; i < templength; ++i)
	{
		if (m_CableSystemName.GetAt(i) != ' ')//there are blanks in strings for numerical value due to the Format of '%15.2f'.
		{
			CableSystems[CurrentSystem].CableSystemName[count] = m_CableSystemName.GetAt(i);
			++count;
		}
	}
	
	CableSystems[CurrentSystem].CableSystemName[count] = '\0';

	//do not change 'CableSystems[CurrentSystem].boolSpecChangebyUser'
}



