#if !defined(AFX_CABLESYSTEMDATAINPUT_H__5C893582_3FC3_47C2_BD3B_46F94874C099__INCLUDED_)
#define AFX_CABLESYSTEMDATAINPUT_H__5C893582_3FC3_47C2_BD3B_46F94874C099__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CableSystemDataInput.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CCableSystemDataInput dialog

class CCableSystemDataInput : public CDialog
{
// Construction
public:
	CCableSystemDataInput(CWnd* pParent = NULL);   // standard constructor

#define MAXCABLESYSTEMS 6

	//Woodam's variables
	int CurrentSystem;

	struct CABLESYSTEMS
	{
		char CableSystemName[20];//name (system and carriage)
		float maxyarddist;//in feet
		float maxlateraldist;//in feet  when [0], this keeps the total number of cable systems available
		float towerheight;//in feet
		float intermediatesupportheight;//in feet
		float maxspartreeheight;
		float minspartreeheight;
		//user-defined payload anaylsis data and variables. All are in metric units
		float gbTmax;
		float gbMmax;
		float gbW1;
		float gbW3;
		float gbW4;
		float gbWc;
		float gbLC;
		float gbCarriageDepth;
		float gbL;
		float gbDLog;
		float gbBeta;
		float gbMyu;
		float gbClearance;
		float gbAllowableDeflection;
		float gbMinSlopewithoutHBL;//minimum slope for tower without haulback in percent.
		float gbMaxSlopeChange;//maximum allowable change in chord slope between adjacent spans
		int gbMaxINTSupports;//limit of the number of INT supports.
		bool boolSpecChangebyUser;//if user-defined variable changes, then has TRUE;
		bool English;//TRUE:English unit
		bool HaulbackLine;//TRUE:Haulbackline available
		bool Downhill;//TRUE:Downhill available

		//other opeartion data
		float gbDensity;
		float gbEngineEfficiency;
		float gbEnginePower;
		float gbHookTime;
		float gbRiggingCosts;
		float gbUnhookTime;
		float gbUnitCost;
		float gbDelayPercentage;
		float gbFellingCosts;
		float gbMoveInCosts;
		float gbYarderSetupHour;
		float gbCableRoadChangeHour;
		float gbUserMaxPayload;
		float gbUserMinPayload;
		float gbLoadFactor;
		float gbInhaulSpeedLimit;
		float gbInhaulSpeedLimitFull;
		float gbOuthaulSpeedLimit;
		float gbLateralYardingSpeed;
		float gbPenaltyForBeyondLateralYarding;
		float gbMultiplierLYD1;
		float gbMultiplierLYD2;
		float gbMultiplierLYD3;
		float gbGiveUpCellDistance;
	} CableSystems[MAXCABLESYSTEMS];
	


// Dialog Data
	//{{AFX_DATA(CCableSystemDataInput)
	enum { IDD = IDD_DIALOGCABLESYSTEM };
	CComboBox	m_CableSystemCtrl;
	float	m_Beta;
	float	m_CarriageDepth;
	float	m_CarriageWeight;
	float	m_HBLWeight;
	float	m_IntermediateHeight;
	float	m_LogDiameter;
	float	m_LogLength;
	float	m_MaxSKLTension;
	float	m_MaxSparHeight;
	float	m_MinSparHeight;
	float	m_MaxLateralYDist;
	float	m_MNLWeight;
	float	m_MaxYardingDist;
	float	m_Myu;
	float	m_SKYWeight;
	float	m_TowerHeight;
	BOOL	m_Check_Downhill;
	BOOL	m_Check_English;
	float	m_Clearance;
	float	m_Deflection;
	float	m_HaulbackLimit;
	float	m_MaxChordSlopeChange;
	CString	m_CableSystem;
	CString	m_CableSystemName;
	BOOL	m_Check_HaulbackLine;
	float	m_ChokerLength;
	int		m_MaxINTSupports;
	float	m_MaxMainTension;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCableSystemDataInput)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:



	// Generated message map functions
	//{{AFX_MSG(CCableSystemDataInput)
	afx_msg void OnCheckDownhill();
	afx_msg void OnCheckEnglishunits();
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeCombCablesystem();
	afx_msg void OnChangeEditBeta();
	afx_msg void OnChangeEditCarriagedepth();
	afx_msg void OnChangeEditCarriageweight();
	afx_msg void OnChangeEditClearance();
	afx_msg void OnChangeEditDeflection();
	afx_msg void OnChangeEditHaulbacklimit();
	afx_msg void OnChangeEditHblweight();
	afx_msg void OnChangeEditIntheight();
	afx_msg void OnChangeEditLogdiam();
	afx_msg void OnChangeEditLoglength();
	afx_msg void OnChangeEditMaxchordslopechange();
	afx_msg void OnChangeEditMaxskltension();
	afx_msg void OnChangeEditMaxsparheight();
	afx_msg void OnChangeEditMinsparheight();
	afx_msg void OnChangeEditMlyd();
	afx_msg void OnChangeEditMnlweight();
	afx_msg void OnChangeEditMyd();
	afx_msg void OnChangeEditMyu();
	afx_msg void OnChangeEditSklweight();
	afx_msg void OnChangeEditTowerh();
	afx_msg void OnInputMore();
	afx_msg void OnCheckHaulbackline();
	afx_msg void OnChangeCablesystemname();
	afx_msg void OnChangeEditChokerlength();
	afx_msg void OnChangeEditMaxintsupport();
	afx_msg void OnChangeEditMaxmaintension();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CABLESYSTEMDATAINPUT_H__5C893582_3FC3_47C2_BD3B_46F94874C099__INCLUDED_)
