// DialogPathAnalysis.cpp : implementation file
//

#include "stdafx.h"
#include "Cablan.h"
#include "DialogPathAnalysis.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDialogPathAnalysis dialog


CDialogPathAnalysis::CDialogPathAnalysis(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogPathAnalysis::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDialogPathAnalysis)
	//}}AFX_DATA_INIT
}


void CDialogPathAnalysis::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogPathAnalysis)
	DDX_Control(pDX, IDC_PICTURE1, m_Picture1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogPathAnalysis, CDialog)
	//{{AFX_MSG_MAP(CDialogPathAnalysis)
	ON_BN_CLICKED(IDC_DRAWPROFILE, OnDrawprofile)
	ON_BN_CLICKED(IDC_LOCATEINTSUPPORT, OnLocateintsupport)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_BN_CLICKED(IDC_REMOVEINTSUPPORT, OnRemoveintsupport)
	ON_BN_CLICKED(IDC_BUTTON_PAYLOADANALYSIS, OnButtonPayloadanalysis)
	ON_BN_CLICKED(IDC_BUTTON_GENERATEINTS, OnButtonGenerateints)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDialogPathAnalysis message handlers

BOOL CDialogPathAnalysis::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	COLORREF Red = RGB(255, 0, 0);
	COLORREF Blue = RGB(0, 0, 255);
	COLORREF Black = RGB(0, 0, 0);
	COLORREF Green = RGB(0, 255, 0);

	brsColor[0].CreateSolidBrush(Black);
	brsColor[1].CreateSolidBrush(Blue);
	brsColor[2].CreateSolidBrush(Red);
	brsColor[3].CreateSolidBrush(Green);

	penColor[0].CreatePen(PS_SOLID, 1, Black);
	penColor[1].CreatePen(PS_SOLID, 1, Blue);
	penColor[2].CreatePen(PS_SOLID, 1, Red);
	penColor[3].CreatePen(PS_SOLID, 1, Green);

	ChangingINTSupportID = -1;
	ChangingTailsparID = -1;//make false so that mouse move is not detected.
	boolLocatingINTSupport = FALSE;
	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CDialogPathAnalysis::OnDrawprofile() 
{
	//draw fish stream in blue color.
	int diffx, diffy;

	CRect ExtentPicture;
	CRect ExtentWindow;
	CRect PosWindow;
	CRect PosPicture;

	GetClientRect(ExtentWindow);
	GetWindowRect(PosWindow);
	m_Picture1.GetClientRect(ExtentPicture);
	m_Picture1.GetWindowRect(PosPicture);

/*
	Coord.top = PosPicture.top - PosWindow.top - 23;
	Coord.bottom = Coord.top + ExtentPicture.bottom;
	Coord.left = PosPicture.left - PosWindow.left - 3;
	Coord.right = Coord.left + ExtentPicture.right;
*/
	Coord.top = 0;
	Coord.bottom = Coord.top + ExtentPicture.bottom + 15;
	Coord.left = 0;
	Coord.right = Coord.left + ExtentWindow.right;


	CClientDC* pDC = new CClientDC(this);

	//clearing the screen
	pDC->SelectStockObject(GRAY_BRUSH);
	pDC->Rectangle(Coord);


	//determine MAX and MIN of elevation
	MaxElev = 0;
	MinElev = 99999999;
	int i;

	for (i = 1; i <= TotalNumberofProfileCells; ++i)
	{
		if (MaxElev < Profile[i].elevation)
			MaxElev = Profile[i].elevation;
		if (MinElev > Profile[i].elevation)
			MinElev = Profile[i].elevation;
	}

	//screen being read to draw
	CSize size, WinSize;
	size.cx = (long)Profile[TotalNumberofProfileCells].flatdistancefromlanding;
	size.cy = (MaxElev - MinElev);
	if (size.cx > size.cy)
		Scale = (long)((double)size.cx * 1.5);
	else
		Scale = (long)((double)size.cy * 1.5);

	Margin = (int) ((double)Scale / 15.);
	
	WinSize.cx = Coord.right - Coord.left;
	WinSize.cy = Coord.bottom - Coord.top;

	pDC->SetMapMode(MM_ISOTROPIC);
	pDC->SetWindowExt(Scale, Scale);
	pDC->SetWindowOrg(0, 0);//negative y is down, positive x is right
	pDC->SelectObject(penColor[0]);


	//set tailspar location
	if (TailLocationID < 0 || TailLocationID > TotalNumberofProfileCells)
		TailLocationID = TotalNumberofProfileCells;
	


	//draw ground profile
	pDC->MoveTo(Coord.left + Margin, -(Coord.top + Margin + MaxElev - Profile[1].elevation));
	
	for (i = 2; i <= TotalNumberofProfileCells; ++i)
	{
		//draw with blue color for fish stream buffer
		if (Profile[i].fishstreambuffer == TRUE)
		{
			//flatdistancefromlanding and elevation is cumulative value. It is necessary to get the difference from the former one.
			diffx = (int)Profile[i].flatdistancefromlanding - (int)Profile[i-1].flatdistancefromlanding;//i starts from 2.
			diffy = Profile[i].elevation - Profile[i-1].elevation;
			if (Profile[i-1].fishstreambuffer == TRUE)
				pDC->SelectObject(penColor[1]);
			else
				pDC->SelectObject(penColor[0]);
			pDC->LineTo(Coord.left + Margin + (int)Profile[i].flatdistancefromlanding-diffx/2, -(Coord.top + Margin + MaxElev - Profile[i].elevation + diffy/2));

			pDC->SelectObject(penColor[1]);
			pDC->LineTo(Coord.left + Margin + (int)Profile[i].flatdistancefromlanding, -(Coord.top + Margin + MaxElev - Profile[i].elevation));
		}
		else
		{
			if (Profile[i-1].fishstreambuffer == TRUE)//if former cell is on stream buffer, then draw blue to the half of profile to the current cell.
			{
				diffx = (int)Profile[i].flatdistancefromlanding - (int)Profile[i-1].flatdistancefromlanding;//i starts from 2.
				diffy = Profile[i].elevation - Profile[i-1].elevation;
				pDC->SelectObject(penColor[1]);
				pDC->LineTo(Coord.left + Margin + (int)Profile[i].flatdistancefromlanding-diffx/2, -(Coord.top + Margin + MaxElev - Profile[i].elevation + diffy/2));
			}
			//otherwise, draw black line through.
			pDC->SelectObject(penColor[0]);
			pDC->LineTo(Coord.left + Margin + (int)Profile[i].flatdistancefromlanding, -(Coord.top + Margin + MaxElev - Profile[i].elevation));
		}
	}

	pDC->SelectObject(penColor[0]);


	//draw x axis ticks.
//	CFont myFont;
//	myFont.CreateFont(20,10,0,0,1,0,0,0,0,0,0,0,0,NULL);
//	pDC->SelectObject(myFont);
	CString tempString;
	pDC->MoveTo(Coord.left + Margin, 0);
	pDC->LineTo(Coord.left + Margin, -Scale/200);
	tempString.Format("%d", 0);
	pDC->TextOut(Coord.left + Margin, 0, tempString);
	
	for (i = 1; i <= TotalNumberofProfileCells; ++i)
	{
		pDC->MoveTo(Coord.left + Margin + (int)Profile[i].flatdistancefromlanding, 0);
		pDC->LineTo(Coord.left + Margin + (int)Profile[i].flatdistancefromlanding, -Scale/300);
		if (i == TotalNumberofProfileCells)
		{
			tempString.Format("%d", (int)Profile[i].flatdistancefromlanding);
			pDC->TextOut(Coord.left + Margin + (int)Profile[i].flatdistancefromlanding, 0, tempString);
		}	
	}

	//draw y axis ticks
	pDC->MoveTo(0, -(Coord.top + Margin + MaxElev - Profile[1].elevation));
	pDC->LineTo(Scale/200, -(Coord.top + Margin + MaxElev - Profile[1].elevation));
	tempString.Format("%d", Profile[1].elevation);
	pDC->TextOut(0, -(Coord.top + Margin + MaxElev - Profile[1].elevation), tempString);

	pDC->MoveTo(0, -(Coord.top + Margin + MaxElev - Profile[TotalNumberofProfileCells].elevation));
	pDC->LineTo(Scale/200, -(Coord.top + Margin + MaxElev - Profile[TotalNumberofProfileCells].elevation));
	tempString.Format("%d", Profile[TotalNumberofProfileCells].elevation);
	pDC->TextOut(0, -(Coord.top + Margin + MaxElev - Profile[TotalNumberofProfileCells].elevation), tempString);
		

	//draw head spar
	CPoint headspar;
	headspar.x = Coord.left + Margin;
	headspar.y = -(Coord.top + Margin + MaxElev - Profile[1].elevation);
	pDC->MoveTo(headspar);
	pDC->LineTo(++headspar.x, headspar.y);
	pDC->LineTo(headspar.x, headspar.y + (int)((double)CableSystems.towerheight));
	pDC->LineTo(--headspar.x, headspar.y + (int)((double)CableSystems.towerheight));
	pDC->LineTo(headspar);


	//draw tail spar
	CPoint tailspar;
	tailspar.x = Coord.left + Margin + (int)Profile[TailLocationID].flatdistancefromlanding;
	tailspar.y = -(Coord.top + Margin + MaxElev - Profile[TailLocationID].elevation);
	pDC->MoveTo(tailspar);
	pDC->LineTo(++tailspar.x, tailspar.y);
	pDC->LineTo(tailspar.x, tailspar.y + (int)((double)SparTreeHeight));//SparTreeHeight is initialized in OnInitDialogue.
	pDC->LineTo(--tailspar.x, tailspar.y + (int)((double)SparTreeHeight));
	pDC->LineTo(tailspar);


	CPoint INTsupport;
	//draw intermediate supports
	for (i = 1; i < TailLocationID; ++i)
	{
		if (boolINTsupport[i] == TRUE)
		{
			INTsupport.x = Coord.left + Margin + (int)Profile[i].flatdistancefromlanding;
			INTsupport.y = -(Coord.top + Margin + MaxElev - Profile[i].elevation);
			pDC->MoveTo(INTsupport);
			pDC->LineTo(++INTsupport.x, INTsupport.y);
			pDC->LineTo(INTsupport.x, INTsupport.y + (int)((double)CableSystems.intermediatesupportheight));
			pDC->LineTo(--INTsupport.x, INTsupport.y + (int)((double)CableSystems.intermediatesupportheight));
			pDC->LineTo(INTsupport);
		}
	}


	//draw selected intermediate support with different color
	if (SelectedINTSLocation  > 0 && SelectedINTSLocation <= TailLocationID)
	{
		pDC->SelectObject(penColor[1]);
		INTsupport.x = Coord.left + Margin + (int)Profile[SelectedINTSLocation].flatdistancefromlanding;
		INTsupport.y = -(Coord.top + Margin + MaxElev - Profile[SelectedINTSLocation].elevation);
		pDC->MoveTo(INTsupport);
		pDC->LineTo(++INTsupport.x, INTsupport.y);
		pDC->LineTo(INTsupport.x, INTsupport.y + (int)((double)CableSystems.intermediatesupportheight));
		pDC->LineTo(--INTsupport.x, INTsupport.y + (int)((double)CableSystems.intermediatesupportheight));
		pDC->LineTo(INTsupport);
	}

	pDC->SelectObject(penColor[0]);



	//draw cable line
	pDC->MoveTo(headspar.x, headspar.y + (int)((double)CableSystems.towerheight));
	for (i = 1; i < TailLocationID; ++i)
	{
		if (boolINTsupport[i] == TRUE)
		{
			INTsupport.x = Coord.left + Margin + (int)Profile[i].flatdistancefromlanding;
			INTsupport.y = -(Coord.top + Margin + MaxElev - Profile[i].elevation);
			pDC->LineTo(INTsupport.x, INTsupport.y + (int)((double)CableSystems.intermediatesupportheight));
		}
	}			
	pDC->LineTo(tailspar.x, tailspar.y + (int)((double)SparTreeHeight));


//	myFont.DeleteObject();

}




void CDialogPathAnalysis::OnLocateintsupport() 
{
	boolLocatingINTSupport = TRUE;	
	SelectedINTSLocation = -1;
	ChangingTailsparID = -1;
}




void CDialogPathAnalysis::OnLButtonDown(UINT nFlags, CPoint point) 
{
	int i;
	int dist;
	int minimumdist = 99999999;
	CString tempString;

	CClientDC* pDC = new CClientDC(this);
	pDC->SetMapMode(MM_ISOTROPIC);
	pDC->SetWindowExt(Scale, Scale);
	pDC->SetWindowOrg(0, 0);//negative y is down, positive x is right

	pDC->DPtoLP(&point);

		
	if (boolLocatingINTSupport == TRUE)
	{
		point.x = (long)(point.x - Coord.left - Margin);
		
		//find column
		for (i = 1; i <= TotalNumberofProfileCells; ++i)
		{
			dist = abs(point.x - (int)Profile[i].flatdistancefromlanding);
			if (minimumdist > dist)
			{
				minimumdist = dist;
				SelectedINTSLocation = i;//global variable				
			}
		}

		if (SelectedINTSLocation > 0)
		{
			if (SelectedINTSLocation == TailLocationID)
			{//change tailspar location-->goto MouseMove()
				ChangingTailsparID = TailLocationID;
				ChangingINTSupportID = -1;//make false so that mouse move is not detected.
			}
			else if (boolINTsupport[SelectedINTSLocation] == TRUE)
			{//change an existing intermediate support-->goto MouseMove()
				ChangingINTSupportID = SelectedINTSLocation;
				ChangingTailsparID = -1;//make false so that mouse move is not detected.
			}
			else 
			{//put a new intermediate support
				if (SelectedINTSLocation < TailLocationID)//only in case that intermediate support location is inside tailspar location.
				{
					boolINTsupport[SelectedINTSLocation] = TRUE;//put a new INT support
					OnDrawprofile();
					ChangingINTSupportID = SelectedINTSLocation;
					ChangingTailsparID = -1;//make false so that mouse move is not detected.
					++TotalNumberofINTs;
				}
				else
					SelectedINTSLocation = -1;
				
			}


			if (TotalNumberofINTs > MAXINTSUPPORT)
			{//more than maximum number of intermediate spars
				boolINTsupport[SelectedINTSLocation] = FALSE;//restore to FALSE
				tempString = "You selected more than a possible number of intermediate spars.";
				AfxMessageBox(tempString, MB_ICONSTOP);
				ChangingTailsparID = -1;//make false so that mouse move is not detected.
				ChangingINTSupportID = -1;//make false so that mouse move is not detected.
				SelectedINTSLocation = -1;
			}
		}
	}


	CDialog::OnLButtonDown(nFlags, point);
}






void CDialogPathAnalysis::OnMouseMove(UINT nFlags, CPoint point) 
{
	int i;
	int dist;
	int minimumdist = 99999999;
	int MoveLocation = -1;

	CClientDC* pDC = new CClientDC(this);
	pDC->SetMapMode(MM_ISOTROPIC);
	pDC->SetWindowExt(Scale, Scale);
	pDC->SetWindowOrg(0, 0);//negative y is down, positive x is right

	pDC->DPtoLP(&point);

	if (ChangingTailsparID > 0)//changing tailspar location
	{
		point.x = (long)(point.x - Coord.left - Margin);
		
		//find the closest cell ID(1~TailLocationID) from click location
		for (i = 1; i <= TotalNumberofProfileCells; ++i)
		{
			dist = abs(point.x - (int)Profile[i].flatdistancefromlanding);
			if (minimumdist > dist)
			{
				minimumdist = dist;
				MoveLocation = i;//global variable
			}
		}

		if (TailLocationID != MoveLocation)//SelectedINTSLocation should be equal to INTSupportLocation[ChangingINTSupportID]. So either way is ok.
		{
			//erase intermediate supports beyond tailspar location
			for (i = MoveLocation; i < TailLocationID; ++i)
			{
				if (boolINTsupport[i] == TRUE)
					boolINTsupport[i] = FALSE;
			}

			TailLocationID = MoveLocation;//reset TailLocationID
			SelectedINTSLocation = MoveLocation;//to draw selected INT
			ChangingTailsparID = MoveLocation;//to keep moving the same INT 
			OnDrawprofile();
		}
	}


		
	if (ChangingINTSupportID > 0)//keep IDnumber for inside []
	{
		point.x = (long)(point.x - Coord.left - Margin);
		
		//find the closest cell ID(1~TailLocationID) from click location
		for (i = 1; i <= TailLocationID; ++i)
		{
			dist = abs(point.x - (int)Profile[i].flatdistancefromlanding);
			if (minimumdist > dist)
			{
				minimumdist = dist;
				MoveLocation = i;//global variable
			}
		}

		if (SelectedINTSLocation > 0 && SelectedINTSLocation != MoveLocation && MoveLocation < TailLocationID)//SelectedINTSLocatio should be equal to INTSupportLocation[ChangingINTSupportID]. So either way is ok.
		{
			boolINTsupport[ChangingINTSupportID] = FALSE;
			boolINTsupport[MoveLocation] = TRUE;
			SelectedINTSLocation = MoveLocation;
			ChangingINTSupportID = MoveLocation;
			OnDrawprofile();
		}
	}
	
	CDialog::OnMouseMove(nFlags, point);
}




void CDialogPathAnalysis::OnLButtonUp(UINT nFlags, CPoint point) 
{
	OnDrawprofile();
	ChangingINTSupportID = -1;//stop moving intermediate support
	ChangingTailsparID = -1;//stop moving intermediate support

	CDialog::OnLButtonUp(nFlags, point);
}



void CDialogPathAnalysis::OnRemoveintsupport() 
{
	CString tempString = "You cannot erase the tailspar!";

	if (SelectedINTSLocation == TailLocationID)
		AfxMessageBox(tempString, MB_ICONSTOP);
	else if (SelectedINTSLocation > 0 && SelectedINTSLocation < TailLocationID)
	{
		if (boolINTsupport[SelectedINTSLocation] == TRUE)
		{
			boolINTsupport[SelectedINTSLocation] = FALSE;
			SelectedINTSLocation = -1;
			OnDrawprofile();			
		}
	}

}




//**********************************************************
//Payload Analysis
//**********************************************************

void CDialogPathAnalysis::OnButtonPayloadanalysis() 
{
	PayloadAnalysis();
}

void CDialogPathAnalysis::GenerateIntermediateSupports()
{
	float aveslope, slope1, slope2, diffx, diffy;
	int i;
	float diff, diff1, diff2;

	//user-defined variables
	float HeadSparHeight = (float)((double)CableSystems.towerheight);//intermediate support height
	float INTHeight = (float)((double)CableSystems.intermediatesupportheight);//intermediate support height
	float TailSparMinHeight = (float)((double)CableSystems.minspartreeheight);//Spartree height
	float TailSparMaxHeight = (float)((double)CableSystems.maxspartreeheight);//Maximum spartree height available
	float TailSparHeight = SparTreeHeight;//SparTreeHeight is set in View().

	float MaxSpan = CableSystems.maxyarddist;
	float MinSlope = gbMinSlopewithoutHBL;//minimum slope for tower without haulback in percent.-> from Doc
	float MaxSlope = (float)gbMaxSlopeChange;//maximum allowable change in chord slope between adjacent spans->convert from percentage.-> from Doc
	int MaxINTSupports = gbMaxINTSupports;//limit of the number of INT supports.
	bool SteepChange;
	bool MoreINTSupportRequired;

	
	//initializing output variables
	memset(boolINTsupport, 0, sizeof(boolINTsupport));
	TotalNumberofINTs = 0;
	


		 
	//select possible intermediate supports
	//1. set intermediate supports in each terrain point
	//2. if the angle between adjacent int. supports


	//change on April 12, 2002
	aveslope = (float)100. * (float)(Profile[1].elevation - Profile[TailLocationID].elevation) / (float)(Profile[1].flatdistancefromlanding - Profile[TailLocationID].flatdistancefromlanding);

	//check if downhill or haulbackline is necessary
	if (aveslope > 0.)//downhill yarding
		AfxMessageBox("Downhill yarding!", MB_ICONSTOP);
	else if (aveslope > MinSlope)
		AfxMessageBox("Haulbackline is necessary", MB_ICONSTOP);
	
	
	//**1. generate all possible intermediate supports -- from Dr.Sessions code
	for (i = 2; i < TailLocationID; ++i)//not include 1 nor TailLocationID because of i-1 and i+1
	{
		if (i == 2)
			diff = HeadSparHeight - INTHeight;
		else if (i == TailLocationID - 1)
			diff = INTHeight - TailSparMinHeight;
		else 
			diff = 0;

		diffx = (float)(Profile[i].flatdistancefromlanding - Profile[i-1].flatdistancefromlanding);
		diffy = (float)(Profile[i].elevation - Profile[i-1].elevation - diff);
		slope1 = diffy / diffx;//slope from behind to current pt.
		diffx = (float)(Profile[i+1].flatdistancefromlanding - Profile[i-1].flatdistancefromlanding);
		diffy = (float)(Profile[i+1].elevation - Profile[i-1].elevation - diff);
		slope2 = diffy / diffx;//slope from behind to ahead pt.

		//permit an intermediate support at convex point (slope1 > slope2)
		if (slope2 < slope1)
		{
			++TotalNumberofINTs;
			boolINTsupport[i] = TRUE;
		}
	}



	//**2. eliminate unecessary intermediate spars -- Woodam's code
	//temporary setting
	boolINTsupport[1] = TRUE;//headspar
	boolINTsupport[TailLocationID] = TRUE;//tailspar

	bool booltemp = FALSE;
	int tempb, tempc;
	while (booltemp == FALSE)
	{
		booltemp = TRUE;
		for (i = 2; i < TailLocationID; ++i)
		{
			if (boolINTsupport[i] == TRUE)
			{
				tempb = LeftSparLocation(i);//find left closest spar location from ith TP.
				tempc = RightSparLocation(i);//find right closest spar location from ith TP.

				if (tempb == 1)//from headspar
					diff1 = HeadSparHeight - INTHeight;
				else
					diff1 = 0;
				if (tempc == TailLocationID)//to tailspar
					diff2 = INTHeight - TailSparHeight;
				else
					diff2 = 0;

				diffx = (float)(Profile[i].flatdistancefromlanding - Profile[tempb].flatdistancefromlanding);
				diffy = (float)(Profile[i].elevation - Profile[tempb].elevation - diff1);
				slope1 = diffy / diffx;//slope from behind to current pt.
				diffx = (float)(Profile[tempc].flatdistancefromlanding - Profile[i].flatdistancefromlanding);
				diffy = (float)(Profile[tempc].elevation - Profile[i].elevation - diff2);
				slope2 = diffy / diffx;//slope from current to ahead pt.
				//slopes are negative when uphill
				//get rid of this INT support
				if (slope2 >= slope1)//????????????
				{
					//concave geographic shape
					boolINTsupport[i] = FALSE;
					--TotalNumberofINTs;
					booltemp = FALSE;
				}
			}
		}
	}



	
	
	//**3. calculate deflection at each terrain point to eliminate unnecessary intermediate supports.
	//temporary variables
	float dx, dy, slope, L, D, P05;
	float his1, his2;
//	int j;

	//user-defined variables
	float Clearance = gbClearance;//from Doc
	float AllowableDeflection = gbAllowableDeflection;//from Doc
	


	if (TotalNumberofINTs > 0)//if there are INT supports.
	{
		for (i = 2; i < TailLocationID; ++i)
		{
			if (boolINTsupport[i] == TRUE)
			{
				tempb = LeftSparLocation(i);//find left closest spar location from ith TP.
				tempc = RightSparLocation(i);//find right closest spar location from ith TP.

				if (tempb == 1)//from headspar
					his1 = HeadSparHeight;
				else 
					his1 = INTHeight;

				if (tempc == TailLocationID)
					his2 = TailSparHeight;
				else
					his2 = INTHeight;
			
				dx = (float) (Profile[tempc].flatdistancefromlanding - Profile[tempb].flatdistancefromlanding);
				dy = (float) (Profile[tempc].elevation + his2 - (Profile[tempb].elevation + his1));
				slope = dy/dx;
	
				L = Profile[i].flatdistancefromlanding - Profile[tempb].flatdistancefromlanding;//distance from i to left INT suppport.
				D = (float)(Profile[tempb].elevation + his1) + slope * L - (float)(Profile[i].elevation + Clearance);//elevation difference without an intermediate support.

				//allowable defelction at point j is being prorated if point j is not at midspan (dx/2)
				if (L < dx/2.)
					P05 = AllowableDeflection * L / (dx/(float)2.);
				else
					P05 = AllowableDeflection * (dx - L) / (dx/(float)2.);
				
				if (D > 0 && D >= P05 * dx)//intermediate support is not necessary.
				{
					boolINTsupport[i] = FALSE;//eliminate intermediate support here 
					//make sure all front TPs are ok without this INT support.
					//go through each TP from the headspar to check clearance
/*
					for (j = 2; j < i; ++j)
					{
						tempb = LeftSparLocation(i);//find left closest spar location from ith TP.
						tempc = RightSparLocation(i);//find right closest spar location from ith TP.

						if (tempb == 1)//from headspar
							his1 = HeadSparHeight;
						else 
							his1 = INTHeight;
			
						if (tempc == TailLocationID)
							his2 = TailSparHeight;
						else
							his2 = INTHeight;
			
						dx = (float) (Profile[tempc].flatdistancefromlanding - Profile[tempb].flatdistancefromlanding);
						dy = (float) (Profile[tempc].elevation + his2 - (Profile[tempb].elevation + his1));
						slope = dy/dx;
	
						L = Profile[j].flatdistancefromlanding - Profile[tempb].flatdistancefromlanding;//distance from j to left INT suppport.
						D = (float)(Profile[tempb].elevation + his1) + slope * L - (float)(Profile[j].elevation);

						if (D < Clearance)//intermediate support is necessary.
						{
							boolINTsupport[i] = TRUE;//restore INT support at ith TP.
							break;
						}
					}
*/
				}
			}
		}
	}
			

	
	//reset Total number of INTs
	TotalNumberofINTs = 0;
	for (i = 2; i < TailLocationID; ++i)//do not include 1 and TailLocationID. They are temporary set as TRUE
	{
		if (boolINTsupport[i] == TRUE)
			++TotalNumberofINTs;
	}



	//**4. Check for too steep a break in chord slope
	///////
	SteepChange = FALSE;
	
	if (TotalNumberofINTs > 0)//if there are INT supports.
	{
		for (i = 2; i < TailLocationID; ++i)
		{
			if (boolINTsupport[i] == TRUE)
			{
				tempb = LeftSparLocation(i);//find left closest spar location from ith TP.
				tempc = RightSparLocation(i);//find right closest spar location from ith TP.

				if (tempb == 1)//from headspar
					diff1 = HeadSparHeight - INTHeight;
				else 
					diff1 = 0;

				if (tempc == TailLocationID)//to tailspar
					diff2 = INTHeight - TailSparMinHeight;
				else 
					diff2 = 0;

				diffx = (float)(Profile[i].flatdistancefromlanding - Profile[tempb].flatdistancefromlanding);
				diffy = (float)(Profile[i].elevation - Profile[tempb].elevation - diff1);
				slope1 = diffy / diffx;//slope from behind to current pt.
				slope1 = (float)atan(slope1);//in degree
				diffx = (float)(Profile[tempc].flatdistancefromlanding - Profile[i].flatdistancefromlanding);
				diffy = (float)(Profile[tempc].elevation - Profile[i].elevation - diff2);
				slope2 = diffy / diffx;//slope from current to ahead pt.
				slope2 = (float)atan(slope2);//in degree

				//not available INT support
				if (fabs(slope2 - slope1) > MaxSlope)
				{
					SteepChange = TRUE;
					AfxMessageBox("Too steep break in chord slope!", MB_ICONSTOP);
				}
			}
		}
	}


	//**5. conduct payload analysis to eliminate the least important intermediate support if there is any limitation on the numberof INT supports
	float tempMaxPayload = 0.;
	int keptINT;
	MoreINTSupportRequired = FALSE;

	if (TotalNumberofINTs > 0 && SteepChange != TRUE)
	{
		while (TotalNumberofINTs > MaxINTSupports)
		{
			keptINT = -1;//initial value
			for (i = 2; i < TailLocationID; ++i)
			{
				if (boolINTsupport[i] == TRUE)
				{
					boolINTsupport[i] = FALSE;//try to eliminate this INT.
					PayloadAnalysis();
					if (tempMaxPayload < MinPayload)
					{
						tempMaxPayload = MinPayload;//MinPayload is determined in PayloadAnalysis()
						keptINT = i;
					}
					boolINTsupport[i] = TRUE;//restore the value.
				}
			}
			
			if (keptINT > 1)
			{
				boolINTsupport[keptINT] = FALSE;//eliminate the selected INT.
				--TotalNumberofINTs;//reduce the number by one.
			}
			else
			{
				MoreINTSupportsRequired = TRUE;
				AfxMessageBox("Failed to reduce the number of intermediate supports!", MB_ICONSTOP);
				break;
			}
		}
	}





	//**7. try to increase tail spar height to eliminate intermediate supports.
	//     conduct payload analysis
	//     calculate unit cost
	//     select the best cable design	



	//temporary resetting
	boolINTsupport[1] = FALSE;//headspar
	boolINTsupport[TailLocationID] = FALSE;//tailspar

	//reset TotalNumber of INTs
	TotalNumberofINTs = 0;
	for (i = 2; i < TailLocationID; ++i)//do not include 1 and TailLocationID. They are temporary set as TRUE
	{
		if (boolINTsupport[i] == TRUE)
			++TotalNumberofINTs;
	}

	//**8. Draw profile and intermediate supports.
	OnDrawprofile();
	
}



int CDialogPathAnalysis::LeftSparLocation(int CurrentTP)
{
	int tempa, tempb;

	tempa = CurrentTP - 1;//start from one cell behind Current TP
	tempb = -1;
	
	while (tempb < 0 && tempa > 0)//get the behind INT support location
	{
		if (boolINTsupport[tempa] == TRUE)
			tempb = tempa;
		else
			--tempa;
	}

	if (tempa < 1)
		tempb = 1;//Headspar-->no intermediate support between headspar and current TP.

	return(tempb);
}



int CDialogPathAnalysis::RightSparLocation(int CurrentTP)
{
	int tempa, tempc;
	
	tempa = CurrentTP + 1;//start from one cell after Current TP
	tempc = -1;
	
	while (tempc < 0 && tempa < TailLocationID)//get the next INT support location
	{
		if (boolINTsupport[tempa] == TRUE)
			tempc = tempa;
		else
			++tempa;
	}

	if (tempa >= TailLocationID)
		tempc = TailLocationID;//Tailspar  --> no intermediate support between tailspar and current TP.

	return(tempc);
}





void CDialogPathAnalysis::PayloadAnalysis()
{
	//this routine is identical to CalculateUniCost() in View...

	//input data from previous subroutines
	//1. Profile[]->information on terrain geometry
	//2. boolINTsupport[]->information on intermediate supports
	//3.
	float HeadSparHeight = (float)((double)CableSystems.towerheight);//intermediate support height
	float INTHeight = (float)((double)CableSystems.intermediatesupportheight);//intermediate support height
	float TailSparHeight = SparTreeHeight;//Spartree height is set in View().
	
	//user-defined variables. All are from Doc
	float Tmax = gbTmax;//conver lb to kg -> 20000lb
	float Mmax = gbMmax;//max mainline tension
	float W1 = gbW1;//unit weight of skyline -> convert 1.04 lb/ft to kg/m
	float W3 = gbW3;//unit weight of mainline
	float W4 = gbW4;//unit weight of haulbackline
	float Wc = gbWc;//carriage weight -> conver lb to kg
	float LC = gbLC;//effective choker length
	float CarriageDepth = gbCarriageDepth;//carriage depth
	float L = gbL;//log length, choker hooked at end of log
	float DLog = gbDLog;//log diameter
	float Beta = gbBeta;//front end log clearance in radian
	float Myu = gbMyu;//coefficient of ground friction
	
	//temporary variables
	int i, j;
	float MinS = (float)999999999.;
	float S;
	int MinSOccuredAt;
	float d1,h1,d2,h2;
	float N[MAXCELLS];
	

	//calculate span distance
	TotalSpans = 1;
	d1 = Profile[1].flatdistancefromlanding;//coordinate rather than distance
	h1 = (float)Profile[1].elevation + HeadSparHeight;

	for (i = 2; i < TailLocationID; ++i)//not include 1 (headspar)
	{
		if (boolINTsupport[i] == TRUE)
		{
			d2 = Profile[i].flatdistancefromlanding;
			h2 = (float)Profile[i].elevation + INTHeight;
			CableLengthatEachSpan[TotalSpans] = (float)sqrt( pow(d2-d1, 2.0) + pow(h2-h1, 2.0) );//global variable to used in other subroutines
			d1 = d2;
			h1 = h2;
			++TotalSpans;//global variable
		}
	}

	d2 = Profile[TailLocationID].flatdistancefromlanding;
	h2 = (float)Profile[TailLocationID].elevation + TailSparHeight;
	CableLengthatEachSpan[TotalSpans] = (float)sqrt( pow(d2-d1, 2.0) + pow(h2-h1, 2.0) );


	//find the shortest streched length of the skyline
	for (i = 2; i < TailLocationID; ++i)//not include 1 (headspar)
	{
		if (boolINTsupport[i] != TRUE)
		{
			if (Profile[i].fishstreambuffer != TRUE)
				S = CalculateStrechedLength(i, Beta, Myu, CarriageDepth, LC, L, HeadSparHeight, INTHeight, TailSparHeight, FALSE);
			else//added on June 4, 2002.
				S = CalculateStrechedLengthbyHC(CarriageDepth+L+LC, i, HeadSparHeight, INTHeight, TailSparHeight, FALSE);//HC = CarriageDepth+L+LC  --> indicates full suspension.
			if (MinS > S)
			{
				MinSOccuredAt = i;
				MinS = S;
			}
		}
	}




	
	///////////////////////////////////////
	//find the minimum payload 	
	///////////////////////////////////////
	
	//temporary variables
	float tBeta1 = (float)0.0;//temporary Beta's
	float tBeta;
	float tempPhi;
	float z1, z2;
	int CriticalTP;
	float NetPayload[MAXCELLS];
	float tempHC[MAXCELLS];
	float slope, slope1, intercept;
	int closesthigherslopepoint = 0;//to check if mainline touches the ground
	float Length1, Length2, Length3, Length4;//cable length for each segment
	float Tav;//upper skyline tension.. (Tav = Tmax - W1*h) It varies depending on headspar or int. support.
	float Mav;//upper mainline tension..
	int leftsparlocation, rightsparlocation;
	float leftsparelevation, rightsparelevation;
	float hc1 = (float)0.0;
	float hc;
	float maxhc;//maximum hc available at each T.P. -> height from flat skyline to the ground
	bool FullSuspension = FALSE;
	CPoint textPosition;
	CString tempString;
	float Tav_reductionfactor;//for reduce Skyline maximum tension when mainline tension is larger than the maximum.

	//initializing 
	for (i = 0; i < MAXCELLS; ++i)
	{
		NormalForce[i] = -1.0;//this variable is set up in the PayloadPartial() and is used in CalculateUnitCosts()
		NetPayload[i] = 0.;//April 20,2002
	}
	

	for (i = 2; i < TailLocationID; ++i)//not include 1 (headspar)
	{
		FullSuspension = FALSE;
		if (boolINTsupport[i] != TRUE)
		{
			//check if full suspension or partial suspension
			leftsparlocation = 0;//if 0, headspar. Otherwise intermediate support.
			rightsparlocation = 0;//if 0, tailspar. Otherwise intermediate support.
			for (j = 2; j < i; ++j)
			{	
				if (boolINTsupport[j] == TRUE)
					leftsparlocation = j;//the closest intermediate support location.
			}
			for (j = TailLocationID + 1; j > i; --j)
			{
				if (boolINTsupport[j] == TRUE)
					rightsparlocation = j;//the closest intermediate support location.
			}

			//calculate elevation of the top of the spars
			if (leftsparlocation > 0)
				leftsparelevation = (float) ( Profile[leftsparlocation].elevation + INTHeight );
			else
			{
				leftsparlocation = 1;//headspar
				leftsparelevation = (float) ( Profile[1].elevation + HeadSparHeight );
			}

			if (rightsparlocation > 0)
				rightsparelevation = (float) ( Profile[rightsparlocation].elevation + INTHeight );
			else
			{
				rightsparlocation = TailLocationID;//tailspar
				rightsparelevation = (float) ( Profile[TailLocationID].elevation + TailSparHeight );
			}

			//slope between two end spars
			slope = (leftsparelevation - rightsparelevation) / (Profile[leftsparlocation].flatdistancefromlanding - Profile[rightsparlocation].flatdistancefromlanding);
			intercept = leftsparelevation - Profile[leftsparlocation].flatdistancefromlanding*slope;
			maxhc = slope * Profile[i].flatdistancefromlanding + intercept;//y = slope*x + intercept
			maxhc -= Profile[i].elevation;//maximum hc available
			
			//guess HC including Carriage depth (from the ground to the skyline)
			hc1 = (float)0.0;
			z2 = (float)99999999.;//keep the minimum z2
			while (hc1 <= maxhc)
			{
				z1 = CalculateStrechedLengthbyHC(hc1, i, HeadSparHeight, INTHeight, TailSparHeight, FALSE) - MinS;
				if (fabs(double(z1)) < fabs(double(z2)))
				{
					hc = hc1;
					z2 = z1;
				}
				hc1 += (float)0.1;
			}
			
					
			if (hc >= CarriageDepth + L + LC)//full
			{
				FullSuspension = TRUE;
				HC = hc;//keep in global variable
				Alpha = (float)(Radians(90.0));//90 degree from the horizon,
				//drawline by TRUE
				z2 = CalculateStrechedLengthbyHC(hc, i, HeadSparHeight, INTHeight, TailSparHeight, TRUE) - MinS;//just for drawing geometry
				DrawLog(i, LC, L, CarriageDepth, Alpha, HC, (float)Radians(90.0)-Phi, Phi);//make Beta + Phi is 90 degree.
			}
			else//partial
			{
				FullSuspension = FALSE;
				//groundslope would be negative when uphill because we locate headspar in left side. 
				tempPhi = (float)atan(-(float)(Profile[i+1].elevation - Profile[i].elevation) / (Profile[i+1].flatdistancefromlanding - Profile[i].flatdistancefromlanding));//we put negative sign because we need to get positive angle for uphill yarding to calculate Alpha. If downhill Phi will be negative value.
				tBeta = 0.0;
				z2 = (float)99999999.;//keep the minimum z2

				//Guess - increase Beta by fixed value
				tBeta1 = 0.0;
				while (tBeta1 <= (float)(90.0*3.141592/180 - tempPhi))//tempPhi is positive when uphill, and negative when downhill
				{
					z1 = CalculateStrechedLength(i, tBeta1, Myu, CarriageDepth, LC, L, HeadSparHeight, INTHeight, TailSparHeight, FALSE) - MinS;
					if (fabs(double(z1)) < fabs(double(z2)) && HC < maxhc)
					{
						z2 = z1;
						tBeta = tBeta1;
					}
					tBeta1 += (float)Radians(0.5);//increase by 0.1 degree
				}
				
				z1 = CalculateStrechedLength(i, tBeta, Myu, CarriageDepth, LC, L, HeadSparHeight, INTHeight, TailSparHeight, TRUE) - MinS;//just for drawing geometry and saving N(normal force)
				DrawLog(i, LC, L, CarriageDepth, Alpha, HC, tBeta, Phi);
			}


			//GlobalHs,GlobalDs, Alpha, Phi, and HC(which includes CarriageDepth) are from CalculatedStrechedLength()
			
			//MAINLINE - Uphill
			//mainline geometry
			//For D, always right - left. For H, always left - right.
			GlobalD3 = Profile[i].flatdistancefromlanding;//right - left-> always positive
			GlobalH3 = (float)(Profile[1].elevation + HeadSparHeight - (Profile[i].elevation + HC - CarriageDepth/2.0));//reverse order (left - right) to make positive slope for uphill yarding (headspar is located in leftside).
			slope = GlobalH3/GlobalD3;//positive slope->Uphill
			

			//check if mainline touches the ground
			closesthigherslopepoint = 0;
			for (j = 1; j < i; ++j)
			{	
				slope1 = (float)(Profile[j].elevation - (Profile[i].elevation + HC - CarriageDepth/2.0)) / (Profile[i].flatdistancefromlanding - Profile[j].flatdistancefromlanding);//reverse order to make positive slope for uphill yarding (headspar is located in leftside).
				if (slope < slope1 && slope > 0)
					closesthigherslopepoint = j;
			}

			//mainline touches the ground-> revise H3 and D3
			if (closesthigherslopepoint > 0)//only if slope > 0 -> only uphill yarding...(do not care downhill)
			{
				GlobalD3 = Profile[i].flatdistancefromlanding - Profile[closesthigherslopepoint].flatdistancefromlanding;//right - left
				GlobalH3 = (float)(Profile[closesthigherslopepoint].elevation - (Profile[i].elevation + HC - CarriageDepth/2.0));//left - right
			}



			//HAULBACKLINE	- Downhill
			//haulbackline geometry --for downhill
			//For D, always right - left. For H, always left - right.
			GlobalD4 = Profile[TailLocationID].flatdistancefromlanding -  Profile[i].flatdistancefromlanding;//right - left-> always positive
			GlobalH4 = (float)(Profile[TailLocationID].elevation + TailSparHeight - (Profile[i].elevation + HC - CarriageDepth/2.0));//right order (right - left) to make positive slope for downhill yarding (tailspar is located in rightside).
			slope = GlobalH4/GlobalD4;//positive slope->Downhill

			//check if mainline touches the ground
			closesthigherslopepoint = 0;
			for (j = TailLocationID - 1; j > i; --j)
			{	
				slope1 = (float)(Profile[j].elevation - (Profile[i].elevation + HC - CarriageDepth/2.0)) / (Profile[j].flatdistancefromlanding - Profile[i].flatdistancefromlanding);
				if (slope < slope1 && slope > 0)
					closesthigherslopepoint = j;
			}

			//mainline touches the ground-> revise H3 and D3
			if (closesthigherslopepoint > 0)//only if slope > 0 -> only uphill yarding...(do not care downhill)
			{
				GlobalD4 = Profile[closesthigherslopepoint].flatdistancefromlanding - Profile[i].flatdistancefromlanding;//right - left
				GlobalH4 = (float)( (Profile[i].elevation + HC - CarriageDepth/2.0) - Profile[closesthigherslopepoint].elevation );//left - right
			}
			else
				GlobalH4 = (float)( (Profile[i].elevation + HC - CarriageDepth/2.0) - Profile[TailLocationID].elevation + TailSparHeight);//(left - right) reverse order so that H4 can be negative value with downhill. This needs for DownhillSegment4()


			//calculate cable length
			Length1 = (float) ( sqrt(pow(GlobalD1,2.0) + pow(GlobalH1,2.0)) );
			Length2 = (float) ( sqrt(pow(GlobalD2,2.0) + pow(GlobalH2,2.0)) );
			Length3 = (float) ( sqrt(pow(GlobalD3,2.0) + pow(GlobalH3,2.0)) );			
			Length4 = (float) ( sqrt(pow(GlobalD4,2.0) + pow(GlobalH4,2.0)) );			


			//Payload analysis*******************
			/////////////////////////////////////
			//Step 1: Line tensions
			if (leftsparelevation > rightsparelevation)//only uphill yarding
			{
				//revised on April 27, 2002.
				if (leftsparlocation > 0)//there is left int support.
				{
					Tav = Tmax - W1 * (Profile[1].elevation + HeadSparHeight - leftsparelevation);//at the headspar, Tav = Tmax
					Mav = Mmax - W3 * (Profile[1].elevation + HeadSparHeight - leftsparelevation);//at the headspar, Tav = Tmax
				}
				else
				{
					Tav = Tmax;//at the headspar
					Mav = Mmax;
				}

				do
				{
					Segment1(Tav, GlobalD1, GlobalH1, Length1, W1);
					Segment2(T1.Right, GlobalD2, GlobalH2, Length2, W1);
					Segment3(GlobalD3, GlobalH3, Length3, W3, Alpha, Wc);
					
					if (T3.Left > Mav)//if mainline tension is bigger than maximum.
					{
						Tav_reductionfactor = (float)((double)Mav / T3.Left / 2.0);
						Tav *= (float)(1.0 - Tav_reductionfactor);
					}

				} while (T3.Left > Mav);
			}
			else//downhill
			{
				//determine maximum tension at the upper location in Segment2 
				if (rightsparlocation > 0)//there is right int support.
					Tav = Tmax - W1 * (Profile[TailLocationID].elevation + TailSparHeight - rightsparelevation);
				else
					Tav = Tmax;//at the tailspar

				DownhillSegment2(Tav, GlobalD2, GlobalH2, Length2, W1);
				DownhillSegment1(T2.Left, GlobalD1, GlobalH1, Length1, W1);
				DownhillSegment4(GlobalD4, GlobalH4, Length4, W4, Alpha, Wc);

			}



			//Step 2: Calculate Payload
			N[i] = (float)0.0;
			if (FullSuspension == TRUE)
				NetPayload[i] = PayloadFull(Wc, HC, i, leftsparlocation, rightsparlocation, HeadSparHeight, INTHeight, TailSparHeight);
			else
			{
				//////////////////////////////////////
				//Fish stream logging restriction
				if (Profile[i].fishstreambuffer == TRUE)
					PartialOnStream = TRUE;
				else
					NetPayload[i] = PayloadPartial(Myu, Wc, Phi, HC, i, leftsparlocation, rightsparlocation, HeadSparHeight, INTHeight, TailSparHeight);
			}

			textPosition.x = (long)Profile[i].flatdistancefromlanding;
			textPosition.y = Profile[i].elevation - 15;
			tempString.Format("%6d", (int)NetPayload[i]);
			WriteText(textPosition, tempString);
			tempHC[i] = HC;
		}
	}

	MinPayload = (float)99999999.9;
	
	for (i = 2; i < TailLocationID; ++i)//not include 1 (headspar)
	{
		//April 20, 2002
		if (MinPayload > NetPayload[i] && boolINTsupport[i] == FALSE)
		{
			MinPayload = NetPayload[i];
			CriticalTP = i;
		}
	}


	//April 20, 2002
	if (MinPayload < 0.)//all netpayload is negative value.
		MinPayload = 0.;

	
	int tempPayload = (int)MinPayload/100;
	tempPayload *= 100;

	tempString.Format("MaxPayload: %5d kg", (int)tempPayload);
	textPosition.x = (long)Profile[1].flatdistancefromlanding;
	textPosition.y = Profile[1].elevation - 100 + Scale/40;
	WriteText(textPosition, tempString);


	float CycleTime = CalculateUnitCost(MinPayload, Myu, HeadSparHeight, MinS, W3, Wc);





	//temporary routine for creating output file--for the purpose of comparing the results with LoggerPC.
	//saving in file
	FILE *outfile_ptr;
	CString csOutFileName = "e:\\thesis\\output\\cableroadprofile.txt";

	outfile_ptr = fopen(csOutFileName, "w");
	
	fprintf(outfile_ptr, "Landing:	%d\n", landingNo);
	fprintf(outfile_ptr, "Cableroad:	%d\n", cablewayNo);
	fprintf(outfile_ptr, "System:	%d\n", systemNo);
	fprintf(outfile_ptr, "Tailspar height:	%d\n", (int)TailSparHeight);
	fprintf(outfile_ptr, "No		Elev.		HorDist		Payload		INT\n");

	for (i = 1; i <= TailLocationID; ++i)//not include 1 (headspar)
	{
		if (boolINTsupport[i] == TRUE)
			fprintf(outfile_ptr, "%d		%d		%f		%f			INT\n", i, Profile[i].elevation, Profile[i].flatdistancefromlanding, NetPayload[i]);	
		else
			fprintf(outfile_ptr, "%d		%d		%f		%f		\n", i, Profile[i].elevation, Profile[i].flatdistancefromlanding, NetPayload[i]);	
	}

	fprintf(outfile_ptr, "MinPayload:	%f\n", MinPayload);

	fclose(outfile_ptr);
	//end of temporary routine

}




float CDialogPathAnalysis::CalculateUnitCost(float MinPayload, float Myu, float HeadSparHeight, float MinStLength, float CableWeight, float CarriageWeight)
{	
	//this routine is identical to CalculateUniCost() in View...


	//Fixed variables
	float G = (float)9.81;// gravity acceleration= 9.81m/sec2
	

	//User-defined variables
	float HooktimeperCM = gbHooktimeperCM;// sec/cubic meter
	float UnhooktimeperCM = gbUnhooktimeperCM;// sec/cubic meter
	float RiggingCosts = gbRiggingCosts;//sec. per intermediate support and tailspar
	float MinpayloadbyUser = gbUserMinPayload;//2200 lb  -> kg
	float Density = gbDensity;//2200 lb / cubic meter  -> kg / cubic meter
	float MaxpayloadbyUser = gbUserMaxPayload;//6600 lb  -> kg
	float LoadFactor = gbLoadFactor;//percent of skyline capacity actually used
	float Cost = gbCableOperationUnitCost;//hourly cost of tower operation $/m3/hour
	float DelayPercentage = gbDelayPercentage;
	float FellingCosts = gbFellingCosts;
	float MoveInCosts = gbMoveInCosts;
	float YarderSetupHour = gbYarderSetupHour;
	float CableRoadChangeHour = gbCableRoadChangeHour;
	float EnginePower = gbEnginePower;//horse power
	float PowerConverterEfficiency = gbEngineEfficiency;//65% of engine power


	
	//temporary variables
	int i;
	float averageYD;//average yarding distance
	float loadsize;
	float load1, load2;
	float cycletime;
	float EmptyTime;//unit: sec
	float LoadedTime;//unit: sec
	float WorkMyuN;
	float slopedist, totalslopedist;
	float liftheight;
	int averageYDlocation;
	float totalwork;
	float availableWatts = EnginePower * PowerConverterEfficiency * (float)746.0;//1hp = 746 Watts  -> Watts ((1N-m)/sec)
	bool PartialSuspension;
	CString tempString;
	CPoint textPosition;
	int NumberofINTs = 0;

	//temporary
	float minimumhaulingtimefromSpeedLimit;

	averageYD = (float)0.67 * MinStLength;//2/3 of total chord distance


	totalslopedist = 0.0;
	WorkMyuN = 0.0;
	PartialSuspension = FALSE;

	//find where this averageYD falls along the skyline corridor.
	for (i = 2; i < TailLocationID; ++i)
	{
		//changed on 4/8/02
		totalslopedist = (float)sqrt( pow((double)(Profile[i].elevation - Profile[1].elevation), 2.0) + pow((double)(Profile[i].flatdistancefromlanding), 2.0) );
		averageYDlocation = i;//will be used to get liftheight.
		if (totalslopedist >= averageYD)
			break;

		if (NormalForce[i] > 0)//until averageYD
		{
			slopedist = (float)sqrt( pow((double)(Profile[i+1].elevation - Profile[i].elevation), 2.0) + pow((double)(Profile[i+1].flatdistancefromlanding - Profile[i].flatdistancefromlanding), 2.0) );
			WorkMyuN += NormalForce[i] * Myu * slopedist;//WorkMyuN is in kg*m, not N*m
			PartialSuspension = TRUE;
		}
		
		//count number of INT supports
		if (boolINTsupport[i] == TRUE)
			++NumberofINTs;
	}

	liftheight = (float)( Profile[1].elevation + HeadSparHeight - (Profile[averageYDlocation].elevation) );//if liftheight is less than 0, that means downhill..
	
	//Temporarily set as positive value ?????
	liftheight = (float)fabs(liftheight);//in case of downhill, the energy will be consumed by haulback line drum. -- assume the same mechanism with mainline drum for uphill.
	

	//determine loadsize---three different load size available:MaxpayloadbyUser, MinPayload from PayloadAnalysis, and MinPayloadbyUser.
	if (MinPayload > MaxpayloadbyUser)
		loadsize = MaxpayloadbyUser;// * LoadFactor;
	else
	{
		load1 = MinPayload;// * LoadFactor;
		load2 = MinpayloadbyUser;//does not need to apply LoadFactor because it is small enough.
		if (load1 > load2)
			loadsize = load1;
		else
			loadsize = load2;
	}

	cycletime = 0.0;
	
	if (liftheight > 0)	//if liftheight is less than 0, that means downhill..
	{
		totalwork = (loadsize + CarriageWeight + MinStLength * CableWeight) * G * liftheight + WorkMyuN * G;//Unit: N-m
		LoadedTime = totalwork / availableWatts;//second
		//once there is at least one partial suspension span, then consider it is partial suspension yarding.....????????
		if (PartialSuspension == TRUE)
		{
			minimumhaulingtimefromSpeedLimit = averageYD / gbInhaulSpeedLimit;//m / (m/sec) = sec
			if (minimumhaulingtimefromSpeedLimit > LoadedTime)
				LoadedTime = minimumhaulingtimefromSpeedLimit;
		}
		else//full suspension
		{
			minimumhaulingtimefromSpeedLimit = averageYD / gbInhaulSpeedLimitFull;//m / (m/sec) = sec
			if (minimumhaulingtimefromSpeedLimit > LoadedTime)
				LoadedTime = minimumhaulingtimefromSpeedLimit;
		}			
	}
	
	//EmptyTime = ((CarriageWeight + MinStLength * CableWeight)* G * liftheight) / availableWatts;//second
	minimumhaulingtimefromSpeedLimit = averageYD / gbOuthaulSpeedLimit;//gbOuthaulSpeedLimit is average outhaul speed
	//if (minimumhaulingtimefromSpeedLimit > EmptyTime)
	EmptyTime = minimumhaulingtimefromSpeedLimit;


	tempString.Format("Loaded: %5.1f min", (float)(LoadedTime/60.));
	textPosition.x = (long)Profile[1].flatdistancefromlanding;
	textPosition.y = Profile[1].elevation - 100;
	WriteText(textPosition, tempString);

	tempString.Format("Empty: %5.1f min", (float)(EmptyTime/60.));
	textPosition.y = Profile[1].elevation - 100 - Scale/40;
	WriteText(textPosition, tempString);
	
	cycletime = (loadsize/Density) * (HooktimeperCM + UnhooktimeperCM) + EmptyTime + LoadedTime;

	tempString.Format("One cycle: %5.1f min", (float)(cycletime/60.));
	textPosition.y = Profile[1].elevation - 100 - 2*Scale/40;
	WriteText(textPosition, tempString);


	//cycletime is one cycletime for average yarding distance which is 2/3 of feasible maximum yarding distance.
	return(cycletime);
}
























void CDialogPathAnalysis::WriteText(CPoint Position, CString tempString)
{
	CClientDC* pDC = new CClientDC(this);
	pDC->SetMapMode(MM_ISOTROPIC);
	pDC->SetWindowExt(Scale, Scale);
	pDC->SetWindowOrg(0, 0);//negative y is down, positive x is right

	Position.x += Coord.left + Margin;
	Position.y = -(Coord.top + Margin + MaxElev - Position.y);
	
	pDC->TextOut(Position.x, Position.y, tempString);
}


void CDialogPathAnalysis::DownhillSegment2(double UpperTension, float d2, float h2, float length2, float w2)
{
	T2.Right = UpperTension;//h2 is negative. This will be UpperTension for Segment 2.
	
	H2.Right = (w2*h2*d2)/(2*length2) + (UpperTension*d2/length2)
				*sqrt(1-pow(((w2*d2)/(2*UpperTension)),2.0));//h2 should be negative because downhill. The first term will be negative because of negative h2.
	
	V2.Right = sqrt(pow(T2.Right,2.0)-pow(H2.Right, 2.0));

	H2.Left = H2.Right;

	V2.Left = (H2.Left*(-h2) - w2*length2*d2/2) / d2;//h2 should be negative->downhill

	T2.Left = sqrt(pow(H2.Left,2.0) + pow(V2.Left, 2.0));
}

void CDialogPathAnalysis::DownhillSegment1(double LowerTension, float d1, float h1, float length1, float w1)
{
	T1.Right = LowerTension;

	H1.Right = (w1*h1*d1)/(2*length1) + (LowerTension*d1/length1)
				*sqrt(1-pow(((w1*d1)/(2*LowerTension)),2.0));//if h1 could be either positive or negative.. depending on carraige elevation and headspar elevation.
															 //if h1 is negative the sign in the eqation will change-->it's ok.
	//if h1 is positive, which means carriage is lower than headspar, the first term should be positive, since Tension in left becomes lower Tension.
	//if h1 is negative, which means carriage is higher than headspar, the first term should be negative, since Tension in left becomes upper tension.


	V1.Right = sqrt(pow(T1.Right,2.0)-pow(H1.Right, 2.0));
	
	H1.Left = H1.Right;
	
	if (h1 < 0)//carriage is higher than headspar
		V1.Left = (H1.Left*(-h1) - w1*length1*d1/2) / d1;//since h1 is negative, the first term will be positive
	else//carriage is lower than headspar
		V1.Left = (H1.Left*h1 + w1*length1*d1/2) / d1;//since h1 is positive, the first term will be positive

	T1.Left = sqrt(pow(H1.Left,2.0) + pow(V1.Left, 2.0));
}



void CDialogPathAnalysis::DownhillSegment4(float d4, float h4, float length4, float w4, float Alpha, float CarriageWeight)
{
	//h4 is negative since downhill.
	double sign1;
	if (GlobalH1 < 0)//carriage is higher than headspar.
		sign1 = -1.0;
	else//carriage is lower than headspar.
		sign1 = 1.0;


	double numerator = tan(Alpha)*(H2.Left-H1.Right)
					   - (V1.Right*sign1+V2.Left-CarriageWeight)//change V1 sign depending on geometry. if h1 is negative V1 should be negative.
		               + (w4*length4)/2;
	double denomenator = fabs((double)(h4/d4)) - tan(Alpha);
	H4.Left = numerator / denomenator;
	
	H4.Right = H4.Left;

	V4.Left = (H4.Left*(-h4) - w4*length4*d4/2) / d4;//h4 is negative.
	
	V4.Right = V4.Left + w4*length4;
	
	T4.Right =  sqrt(pow(H4.Right,2.0) + pow(V4.Right, 2.0));
	T4.Left =  sqrt(pow(H4.Left,2.0) + pow(V4.Left, 2.0));
}




void CDialogPathAnalysis::Segment1(double UpperTension, float d1, float h1, float length1, float w1)
{
	T1.Left = UpperTension;

	H1.Left = -(w1*h1*d1)/(2*length1) + (UpperTension*d1/length1)
				*sqrt(1-pow(((w1*d1)/(2*UpperTension)),2.0));//if h1 should be positive, because uphill

	V1.Left = sqrt(pow(T1.Left,2.0)-pow(H1.Left, 2.0));
	
	H1.Right = H1.Left;

	V1.Right = (H1.Right*h1 - w1*length1*d1/2) / d1;//h1 is positive

	T1.Right = sqrt(pow(H1.Right,2.0) + pow(V1.Right, 2.0));
}


void CDialogPathAnalysis::Segment2(double LowerTension, float d2, float h2, float length2, float w2)
{
	T2.Left = LowerTension;//if h2 is positive (carriage is higher than tailspar). This will be UpperTension for Segment 2.
	
	H2.Left = -(w2*h2*d2)/(2*length2) + (LowerTension*d2/length2)
				*sqrt(1-pow(((w2*d2)/(2*LowerTension)),2.0));//if h2 is negative, it automatically change the sign in the equation. O.K.
	

	//if the geometry shows carriage is SLIGHTLY lower than tail spar (negative h2 here), but because of cable weight T2.left could be upper tension.
	if (H2.Left > T2.Left)
	{
		H2.Left = (w2*h2*d2)/(2*length2) + (LowerTension*d2/length2)
				*sqrt(1-pow(((w2*d2)/(2*LowerTension)),2.0));
		
		V2.Left = -sqrt(pow(T2.Left,2.0)-pow(H2.Left, 2.0));//put negative so that this will be counted as force against payload.
	}
	else
		V2.Left = sqrt(pow(T2.Left,2.0)-pow(H2.Left, 2.0));


	H2.Right = H2.Left;

	if (h2 >= 0)//carriage is higher than tailspar
		V2.Right = (H2.Right*h2 - w2*length2*d2/2) / d2;//since h2 is positive, the first first term will be positive
	else//carriage is lower than tailspar
		V2.Right = (H2.Right*(-h2) + w2*length2*d2/2) / d2;//since h2 is negative, the first term will be positive.

	T2.Right = sqrt(pow(H2.Right,2.0) + pow(V2.Right, 2.0));

}


void CDialogPathAnalysis::Segment3(float d3, float h3, float length3, float w3, float Alpha, float CarriageWeight)
{
	double sign2;
	if (GlobalH2 >= 0)//carriage is higher than tailspar.
		sign2 = -1.0;
	else//carriage is lower than tailspar.
		sign2 = 1.0;


	double numerator = tan(Alpha)*(H1.Left-H2.Right)
					   - (V1.Right+V2.Left*sign2-CarriageWeight)//change V2 sign depending on geometry. if h2 is positive(carriage is higher than tail) V2 should be negative.
		               + (w3*length3)/2;
	double denomenator = fabs((double)(h3/d3)) - tan(Alpha);//h3 should be positive, since uphill yarding.

	H3.Right = numerator / denomenator;
	
	H3.Left = H3.Right;

	V3.Right = (H3.Right*h3 - w3*length3*d3/2) / d3;//applicable for only uphill yarding. h3 should be positive
	
	V3.Left = V3.Right + w3*length3;
	
	T3.Right =  sqrt(pow(H3.Right,2.0) + pow(V3.Right, 2.0));
	T3.Left =  sqrt(pow(H3.Left,2.0) + pow(V3.Left, 2.0));
}


float CDialogPathAnalysis::PayloadPartial(float Myu, float CarriageWeight, float Phi, float HC, int TP, int leftsparlocation, int rightsparlocation, float HeadSparHeight, float INTHeight, float TailSparHeight)
{
	//this routine is identical to CalculateUniCost() in View...

	float NetLoad = 0.0;
	float N = 0.0;
	float sparheight;
	double sign1, sign2, sign3, sign4;
	float leftsparelevation, rightsparelevation;
	float tempMyu;

	if (leftsparlocation > 1)
		sparheight = (float)INTHeight;
	else
		sparheight =  (float)HeadSparHeight;

	leftsparelevation = (float) ( Profile[leftsparlocation].elevation + sparheight );

	if (rightsparlocation < TailLocationID && rightsparlocation > 0)
		sparheight = (float)INTHeight;
	else
		sparheight =  (float)TailSparHeight;

	rightsparelevation = (float) ( Profile[rightsparlocation].elevation + sparheight );
	

	//decide uphill or downhill
	if (leftsparelevation > rightsparelevation)//uphill
	{
		sign3 = 1.0;
		sign4 = 0.0;
		N = (float) ( (H1.Right + H3.Right - H2.Left) / (sin(Phi)+Myu*cos(Phi)) );//denomenator (sin and cos) works for both downhill and uphill. Down hill has negative Phi.
	}
	else//downhill
	{
		sign3 = 0.0;
		sign4 = 1.0;
	
		tempMyu = Myu;
		while (sin(Phi)+tempMyu*cos(Phi) < 0)//if Phi is steep downhill slope, N could be negative value. So increase Myu to avoid a negative N.
			tempMyu += (float)Radians(1.0);
		
		N = (float) ( (-H1.Right + H2.Left + H4.Left) / (sin(Phi)+tempMyu*cos(Phi)) );//sin and cos works for both downhill and uphill. Down hill has negative Phi.
	}
	
	
	if (Profile[TP].elevation + HC > leftsparelevation)//carriage is higher than headspar -> h1 is negative (downhill)
		sign1 = -1.0;//downhill
	else
		sign1 = 1.0;//uphill
	
	if (Profile[TP].elevation + HC > rightsparelevation)//carriage is higher than tailspar -> h2 is positive (uphill)
		sign2 = -1.0;
	else //downhill
		sign2 = 1.0;
	
	
	NetLoad = (float) ( (sign1*V1.Right + sign3*V3.Right + sign2*V2.Left + sign4*V4.Left - CarriageWeight) + N*cos(Phi) - Myu*N*sin(Phi) );
	
	NormalForce[TP] = N;
	return(NetLoad);
}



float CDialogPathAnalysis::PayloadFull(float CarriageWeight, float HC, int TP, int leftsparlocation, int rightsparlocation, float HeadSparHeight, float INTHeight, float TailSparHeight)
{
	//this routine is identical to CalculateUniCost() in View...


	float NetLoad = 0.0;
	double sign1, sign2, sign3, sign4;
	float leftsparelevation, rightsparelevation;

	if (leftsparlocation > 1)
		leftsparelevation = (float) ( Profile[leftsparlocation].elevation + INTHeight );
	else
		leftsparelevation = (float) ( Profile[1].elevation + HeadSparHeight );

	if (rightsparlocation < TailLocationID && rightsparlocation > 0)
		rightsparelevation = (float) ( Profile[rightsparlocation].elevation + INTHeight );
	else
		rightsparelevation = (float) ( Profile[TailLocationID].elevation + TailSparHeight );

	//decide uphill or downhill
	if (leftsparelevation > rightsparelevation)//uphill
	{
		sign3 = 1.0;
		sign4 = 0.0;
	}
	else//downhill
	{
		sign3 = 0.0;
		sign4 = 1.0;
	}


	if (Profile[TP].elevation + HC > leftsparelevation)//carriage is higher than headspar -> h1 is negative (downhill)
		sign1 = -1.0;//downhill
	else
		sign1 = 1.0;//uphill
	
	if (Profile[TP].elevation + HC > rightsparelevation)//carriage is higher than tailspar -> h2 is positive (uphill)
		sign2 = -1.0;
	else //downhill
		sign2 = 1.0;


	NetLoad = (float) ( (sign1*V1.Right + sign3*V3.Right + sign2*V2.Left + sign4*V4.Left - CarriageWeight) );

	return(NetLoad);

}




float CDialogPathAnalysis::CalculateStrechedLength(int TP, float Beta, float Myu, float CarriageDepth, float LC, float L, float HeadSparHeight, float INTHeight, float TailSparHeight, bool Draw)
{
	//temporary variables
	int j;
	float groundslope;
	int leftINTsupportlocation;//to identify we are heading to another INT support
	int rightINTsupportlocation;//to identify we are coming from another INT support
	float S;
	float d1,h1,d2,h2;
	CPoint From, To, From1;
	int SpanNo;


	//calculate streched length of the skyline at the given T.P.

	//let's figure out where I am. (which span)
	leftINTsupportlocation = 1;
	rightINTsupportlocation = TailLocationID;
	SpanNo = 1;//count spans to know where I am. 1 means we are going directly to headspar.
		
	for (j = 2; j < TP; ++j)//not include 1 (headspar)
	{
		if (boolINTsupport[j] == TRUE)
		{
			leftINTsupportlocation = j;//keep the closest int. support location in left side
			++SpanNo;
		}
	}	

	for (j = TailLocationID - 1; j > TP ; --j)//start checking backward
	{
		if (boolINTsupport[j] == TRUE)
			rightINTsupportlocation = j;//keep the closest int. support location in right side
	}


	//calculate Phi (ground angle from the current T.P. to left T.P. toward headspar)
	groundslope = (float)(Profile[TP+1].elevation - Profile[TP].elevation) / (Profile[TP+1].flatdistancefromlanding - Profile[TP].flatdistancefromlanding);
	//groundslope would be negative when uphill because we locate headspar in left side. 
	Phi = (float)atan(-groundslope);//we put negative sign because we need to get positive angle for uphill yarding to calculate Alpha. If downhill Phi will be negative value.-->global variable
			
	//calculate Alpha
	Alpha = (float)fabs(atan(2.*tan(Phi+Beta) + (cos(Phi)-Myu*sin(Phi))/(sin(Phi)+Myu*cos(Phi))));//alpha should be in positive no matter of downhill or uphill.-->global variable

	//calculate HC
	HC = (float) ( (LC*sin(Alpha - Phi) + L*sin(Beta)) / cos(Phi) + CarriageDepth ); //global variable
	

	//calculate d and h
	//d's are alwayas positive (right - left)
	//h's could be positive or negative (left - right)
	if (leftINTsupportlocation > 1)//heading to an intermediate support
	{
		d1 = (float)(Profile[TP].flatdistancefromlanding - Profile[leftINTsupportlocation].flatdistancefromlanding);//distance between Int. support and current T.P.  -> always right T.P. - left T.P.. Always be positive
		h1 = (float)(Profile[leftINTsupportlocation].elevation + INTHeight - (Profile[TP].elevation + HC));//always left T.P. - right T.P. -> with down hill h1 will be negative.  -> useful when calculate H1L
		From.x = (long)Profile[leftINTsupportlocation].flatdistancefromlanding;
		From.y = (long)( Profile[leftINTsupportlocation].elevation + INTHeight );
	}
	else//heading to the headspar
	{
		d1 = (float)Profile[TP].flatdistancefromlanding;//distance between headspar and current T.P.
		h1 = (float)(Profile[1].elevation + HeadSparHeight - (Profile[TP].elevation + HC));
		From.x = (long)Profile[1].flatdistancefromlanding;
		From.y = (long)( Profile[1].elevation + HeadSparHeight );
	}
		
	To.x = (long) Profile[TP].flatdistancefromlanding;
	To.y = (long)( Profile[TP].elevation + HC );
	
	if (Draw == TRUE)
		DrawAnythingToTest(From, To, 0);


	if (rightINTsupportlocation < TailLocationID)//from an intermediate support
	{
		d2 = (float)(Profile[rightINTsupportlocation].flatdistancefromlanding - Profile[TP].flatdistancefromlanding);//distance between Int. support and current T.P.; right - left
		h2 = (float)((Profile[TP].elevation + HC) - (Profile[rightINTsupportlocation].elevation + INTHeight));//left - right
		From1.x = (long)Profile[rightINTsupportlocation].flatdistancefromlanding;
		From1.y = (long) ( Profile[rightINTsupportlocation].elevation + INTHeight );
	}
	else//from tailspar
	{
		d2 = (float)(Profile[TailLocationID].flatdistancefromlanding - Profile[TP].flatdistancefromlanding);//distance between current T.P. and tailspar
		h2 = (float)((Profile[TP].elevation + HC) - (Profile[TailLocationID].elevation + TailSparHeight) );//left - right
		From1.x = (long)Profile[TailLocationID].flatdistancefromlanding;
		From1.y = (long)( Profile[TailLocationID].elevation + TailSparHeight );
	}
	
	
	if (Draw == TRUE)
		DrawAnythingToTest(From1, To, 0);


	//calculate S
	S = (float)( sqrt(pow(d1,2.0)+pow(h1,2.0)) + sqrt(pow(d2,2.0)+pow(h2,2.0)) );
	
	for (j = 1; j <= TotalSpans; ++j)//add other spans (assumed as a straight line) if there are.
	{
		if (j != SpanNo && CableLengthatEachSpan[j] > 0)
			S += CableLengthatEachSpan[j];//CableLengthatEachSpan[] is global variable and already set in PayloadAnalysis().
	}

	//store the value into global variables
	GlobalD1 = d1;
	GlobalD2 = d2;
	GlobalH1 = h1;
	GlobalH2 = h2;

	return(S);
}





float CDialogPathAnalysis::CalculateStrechedLengthbyHC(float HC, int TP, float HeadSparHeight, float INTHeight, float TailSparHeight, bool Draw)
{
	//if we know HC (including CarriageDepth, so from the ground to Skyline),
	//we can calculate total streched lenght of skyline

	//temporary variables
	int j;
	int leftINTsupportlocation;//to identify we are heading to another INT support
	int rightINTsupportlocation;//to identify we are coming from another INT support
	float S;
	float d1,h1,d2,h2;
	CPoint From, To, From1;
	int SpanNo;


	//calculate streched length of the skyline at the given T.P.

	//let's figure out where I am. (which span)
	leftINTsupportlocation = 1;
	rightINTsupportlocation = TailLocationID;
	SpanNo = 1;//count spans to know where I am. 1 means we are going directly to headspar.
		
	for (j = 2; j < TP; ++j)//not include 1 (headspar)
	{
		if (boolINTsupport[j] == TRUE)
		{
			leftINTsupportlocation = j;//keep the closest int. support location in left side
			++SpanNo;
		}
	}	

	for (j = TailLocationID - 1; j > TP ; --j)//start checking backward
	{
		if (boolINTsupport[j] == TRUE)
			rightINTsupportlocation = j;//keep the closest int. support location in right side
	}


	//calculate d and h
	if (leftINTsupportlocation > 1)//heading to an intermediate support
	{
		d1 = (float)(Profile[TP].flatdistancefromlanding - Profile[leftINTsupportlocation].flatdistancefromlanding);//distance between Int. support and current T.P.  -> always right T.P. - left T.P.. Always be positive
		h1 = (float)(Profile[leftINTsupportlocation].elevation + INTHeight - (Profile[TP].elevation + HC));//always left T.P. - right T.P. -> with down hill h1 will be negative.  -> useful when calculate H1L
		From.x = (long)Profile[leftINTsupportlocation].flatdistancefromlanding;
		From.y = (long)( Profile[leftINTsupportlocation].elevation + INTHeight );
	}
	else//heading to the headspar
	{
		d1 = (float)Profile[TP].flatdistancefromlanding;//distance between headspar and current T.P.
		h1 = (float)(Profile[1].elevation + HeadSparHeight - (Profile[TP].elevation + HC));
		From.x = (long)Profile[1].flatdistancefromlanding;
		From.y = (long)( Profile[1].elevation + HeadSparHeight );
	}
		
	To.x = (long) Profile[TP].flatdistancefromlanding;
	To.y = (long)( Profile[TP].elevation + HC );
	
	if (Draw == TRUE)
		DrawAnythingToTest(From, To, 0);


	if (rightINTsupportlocation < TailLocationID)//from an intermediate support
	{
		d2 = (float)(Profile[rightINTsupportlocation].flatdistancefromlanding - Profile[TP].flatdistancefromlanding);//distance between Int. support and current T.P.; right - left
		h2 = (float)((Profile[TP].elevation + HC) - (Profile[rightINTsupportlocation].elevation + INTHeight));//left - right
		From1.x = (long)Profile[rightINTsupportlocation].flatdistancefromlanding;
		From1.y = (long) ( Profile[rightINTsupportlocation].elevation + INTHeight );
	}
	else//from tailspar
	{
		d2 = (float)(Profile[TailLocationID].flatdistancefromlanding - Profile[TP].flatdistancefromlanding);//distance between current T.P. and tailspar
		h2 = (float)((Profile[TP].elevation + HC) - (Profile[TailLocationID].elevation + TailSparHeight) );//left - right
		From1.x = (long)Profile[TailLocationID].flatdistancefromlanding;
		From1.y = (long)( Profile[TailLocationID].elevation + TailSparHeight );
	}
			
	if (Draw == TRUE)
		DrawAnythingToTest(From1, To, 0);


	//calculate S
	S = (float)( sqrt(pow(d1,2.0)+pow(h1,2.0)) + sqrt(pow(d2,2.0)+pow(h2,2.0)) );
	
	for (j = 1; j <= TotalSpans; ++j)//add other spans (assumed as a straight line) if there are.
	{
		if (j != SpanNo && CableLengthatEachSpan[j] > 0)
			S += CableLengthatEachSpan[j];//CableLengthatEachSpan[] is global variable and already set in PayloadAnalysis().
	}

	//store the value into global variables
	GlobalD1 = d1;
	GlobalD2 = d2;
	GlobalH1 = h1;
	GlobalH2 = h2;

	return(S);
}











void CDialogPathAnalysis::DrawAnythingToTest(CPoint From, CPoint To, int PenColor)
{
	CClientDC* pDC = new CClientDC(this);
	pDC->SetMapMode(MM_ISOTROPIC);
	pDC->SetWindowExt(Scale, Scale);
	pDC->SetWindowOrg(0, 0);//negative y is down, positive x is right

	if (PenColor > 0)
		pDC->SelectObject(penColor[PenColor]);

	From.x += Coord.left + Margin;
	To.x += Coord.left + Margin;
	From.y = -(Coord.top + Margin + MaxElev - From.y);
	To.y = -(Coord.top + Margin + MaxElev - To.y);

	pDC->MoveTo(From);
	pDC->LineTo(To);
}


void CDialogPathAnalysis::DrawLog(int i, float LC, float L, float CarriageDepth, float Alpha, float HC, float Beta, float Phi)
{
	//draw tagline
	CPoint tl, cp;
	cp.x = (long)Profile[i].flatdistancefromlanding;
	cp.y = (long)(Profile[i].elevation + HC - CarriageDepth);

	
	tl.x = (long)( Profile[i].flatdistancefromlanding + (long)(LC*cos(Alpha)) );
	tl.y = (long)( cp.y - (long)(LC*sin(Alpha)) );

	DrawAnythingToTest(cp, tl, 0);
	
	//draw log dragging 
	CPoint ld;
	ld.x = (long)( tl.x + (long)(L*cos( Beta+Phi )) );
	ld.y = (long)( tl.y - (long)(L*sin( Beta+Phi )) );
	
	DrawAnythingToTest(tl, ld, 0);
	
}


double CDialogPathAnalysis::Radians(double Degree)
{
	double Radian = Degree * 3.141592 / 180.0;
	return (Radian);
}




void CDialogPathAnalysis::OnButtonGenerateints() 
{
	SelectedINTSLocation = -1;
	GenerateIntermediateSupports();
	PayloadAnalysis();
}
